<?php

include '../core.php';

session_start();

cabecera (1);

// El siguiente script comprueba si el identificador de la
// solicitud es valido, antes de enviar el formulario.
echo "<script language='JavaScript'>
<!--
function submit_form()
{
if (document.crt_form.crt_ID.value == '') {
alert ('Por favor introduzca un Identificador valido');
document.crt_form.crt_ID.focus();
return false;
}
document.crt_form.submit();
return true;
}
// -->
</script>

<h1>Descarga de certificados solicitados a $pkiName</h1>\n";

// Dependiendo del valor de esta variable entraremos en una 
// u otra parte del codigo
$command = $_POST["crt_command"];

switch ( $command ) {
   
   // Por defecto solicitamos al usuario el identificador del 
   // certificados que quiere obtener
   default:
	   
      echo "<p>En este apartado podr&aacute; descargarse el certificado que haya solicitado previamente. Tanto sea de usuario como de servicio/servidor. No olvide que los identificadores normalmente son de la forma:</p>
      <ul>
        <li><b>Usuario:</b> nombre.apellido@organizaci&oacute;n</li>
        <li><b>Servidor:</b> FQDN.del.servidor</li>
        <li><b>Servicio:</b> servicio/FQDN.del.servidor</li>
      </ul>
      
      <div id='tbox'>
         <h3 class='head_a2b1'>Introduzca los datos</h3>
	    <div id='tbox_data_a1'>
      	    <form method='post' action='crt_get.php' name='crt_form'>
	    <div id='trow'>
	    <div id='tname'>Identificador de<br/>usuario/servidor:</div>
	       <div id='tvalue'><input type='text' name='crt_ID'  size='30' minlen='7' /></div>
	    </div>
	    <div id='trow'>
               <div id='tvalue'>
                  <input class='button' type='button' value='Continuar' onClick='submit_form()'></div>
	    </div>
      	    <input type='hidden' name='crt_command' value='crt_show'>
            </form>
         </div> <!-- tbox_data_a1 -->
      </div> <!-- tbox -->";

   break;
   
   // En esta parte se muestra informacion sobre el usuario y se le pregunta
   // que certificado quiere descargarse (en el caso de que tenga mas de uno)   
   case "crt_show":
     
      // Buscamos la informacion del usuario para presentar su informacion
      $filter = "(&(objectClass=pkirisEndEntity)(pkirisID=$crt_ID))";
      $errorNumber = 0;
      $justthese = array("cn", "sn"); 

      $result = ldap_get_info($base, $filter, $justthese); 
      
      if (!$result){
         $errorNumber = 69;
         echo "<h2>El dentificador del usuario/servidor no pertenece a ninguna RA.</h2>";
      }
      else {
        
	 $cn = $result[0]["cn"][0];
         $sn = $result[0]["sn"][0];
	       
         // Buscamos la informacion de los certificados que tenga 
         // el usuario en estado SIGNED
         $filter = "(&(objectClass=pkirisCertificate)(pkirisID=$crt_ID)(pkirisStatus=issued))";
         $justthese = array("pkiriscopaid", "pkiriscerttype");

         $result = ldap_get_info($base, $filter, $justthese);

         if (!$result){
            $errorNumber = 69;
            echo "<h2>El identificador $crt_ID pertenece al usuario $cn $sn, pero no es un certificado v&aacute;lido.</h2>";
         }
         else {

	    $crt_type = $result[0]["pkiriscerttype"][0];
	       
  	    // Si el usuarios tiene mas de un certificado firmado, le 
	    // tenemos que dar la posibilidad de descargarse cualquiera 
	    if ($result["count"] > 1) { 
	       echo "<p>Actualmente dispone de varios certificados firmados. Escoja el que desee descargar.</p>";
	          
	       echo "<h2>Datos sobre la solicitud del certificado (CSR)</h2>
               <table border='0' cellpadding='0' cellspacing='0'>
               <tr><td class='header'>Identificador</td><td class='even'>$crt_ID</td></tr>";

	       // El siguiente formulario muestra el primer certificado
	       $copaCrt1 = $result[0]["pkiriscopaid"][0];
               echo "<form method='post' action='crt_get.php' enctype='multipart/form-data'>
	       <tr><td class='header'>C&oacute;digo de solicitud</td><td class='odd'> $copaCrt1 				    
	       <input type=submit value='Mostrar'> </td></tr>
	       <input type='hidden' name='crt_command' value='crt_show2'>
               <input type='hidden' name='crt_serial' value='$copaCrt1'>
               <input type='hidden' name='crt_id' value='$crt_ID'>
               <input type='hidden' name='crt_cn' value='$cn'>
               <input type='hidden' name='crt_sn' vaue='$sn'>
               <input type='hidden' name='crt_type' value='$crt_type'>
               </form>";
		  
	       // Formulario para mostrar el segundo certificado disponible
	       $copaCrt2 = $result[1]["pkiriscopaid"][0];
	       echo "<form method='post' action='crt_get.php' enctype='multipart/form-data'>
	       <tr><td class='header'>C&oacute;digo de solicitud</td><td class='even'> $copaCrt2
	       <input type=submit value='Mostrar'> </td></tr>
	       <input type='hidden' name='crt_command' value='crt_show2'>
	       <input type='hidden' name='crt_serial' value=$copaCrt2>
	       <input type='hidden' name='crt_id' value='$crt_ID'>
	       <input type='hidden' name='crt_cn' value='$cn'>
	       <input type='hidden' name='crt_sn' vaue='$sn'>
	       <input type='hidden' name='crt_type' value='$crt_type'>
	       </form>";

		     
	       echo "<tr><td class='header'>Nombre</td><td class='odd'>" . $cn . " " . $sn ."</td></tr>";
               // Dependiendo del tipo de solicitud, mostraremos 
               // un mensaje u otro
               if ($result[0]["pkiriscerttype"][0] == "srv") 
                  echo "<tr><td class='header'>Tipo</td><td class='even'>Certificado de Servidor</td></tr></table>";
	       else 
	          echo "<tr><td class='header'>Tipo</td><td class='even'>Certificado de Usuario</td></tr></table>";
		  
	    }
	    else {
	       // Si el usuario solamente dispone de un certificado firmado, 
	       // se lo mostramos directamente	       
	       $copa = $result[0]["pkiriscopaid"][0];
	       echo "<form method='post' action='crt_get.php' enctype='multipart/form-data' name='crt_form'>
               <input type='hidden' name='crt_command' value='crt_show2'>
               <input type='hidden' name='crt_copa' value='$copa'>
               <input type='hidden' name='crt_ID' value='$crt_ID'>
               <input type='hidden' name='crt_cn' value='$cn'>
               <input type='hidden' name='crt_sn' vaue='$sn'>
               <input type='hidden' name='crt_type' value='$crt_type'>
	       <body onLoad='document.crt_form.submit()'>
               </form>";
	    }	       
	 }   
      }
      break;
  
  // En esta parte se muestra el contenido del certificado y se permite 
  // la descarga
  case "crt_show2":
     
     echo "<h2>Datos sobre la solicitud del certificado (CSR)</h2>
     <table border='0' cellpadding='0' cellspacing='0'>
     <tr><td class='header'>Identificador</td><td class='even'>$crt_ID</td></tr>
     <tr><td class='header'>C&oacute;digo de solicitud</td><td class='odd'>$crt_copa
     <tr><td class='header'>Nombre</td><td class='even'>" . $crt_cn . " " . $crt_sn ."</td></tr>";     
     // Dependiendo del tipo de solicitud, mostraremos un mensaje u otro, y 
     // crearemos un fichero u otro para guardar el certificado
     if ($crt_type == "srv") {
        echo "<tr><td class='header'>Tipo</td><td class='odd'>Certificado de Servidor</td></tr></table>";
	$crtFileName = $crt_copa.".cer";
     }
     else {
        echo "<tr><td class='header'>Tipo</td><td class='odd'>Certificado de Usuario</td></tr></table>";
	$crtFileName = $crt_copa.".cer";
     }
     // Obtenemos el certificado del ldap	     
     $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$crt_copa)(pkirisStatus=issued))";
     $userCert = ldap_get_cert($base, $filter);

     // Si ha habido algun error, mostramos mensaje y no continuamos con la descarga
     if (!$userCert){
	$errorNumber = 69;
        echo "<h2>No se ha podido obtener el certificado.</h2>";
     }
     else {							 

        echo "<br />
	<p> Para instalar el certificado en su navegador es necesario que utilice el mismo navegador desde el que realizó la petición del certificado. En caso contrario no podrá instalarlo</p>
        <form method='post' action='crt_get.php' enctype='multipart/form-data'>
        <input class='button' type=submit value='Instalar su certificado en el navegador'>
        <input type='hidden' name='crt_copa' value='$crt_copa'>
        <input type='hidden' name='crt_command' value='crt_download'>
	<input type='hidden' name='crt_type' value='$crt_type'>
	<input type='hidden' name='crtFileName' value='$crtFileName'> 
        </form>

        <h2>Datos sobre el certificado que va a descargar</h2>
	<div id='tbox'>
	  <h3 class='head_a2b1'>Certificado</h3>
	      <div id='tbox_data_a1'><pre>\n";
        
	// Verificamos si existe el fichero y si no lo creamos
        // y volcamos la info del certificado en el
	$derFile = $crtData . $crtFileName;
        if (!file_exists($derFile)) {
           $der = fopen($derFile, "w");
           fputs($der, $userCert[0]);
           fclose($der);
        }

       // Pasamos el certificado que esta en der a txt y lo 
       // tenemos en un array para manipularlo. (NO LO PASAMOS A DISCO)
       $txtCert = exec($binOpenssl . " x509 -text -inform DER < " .$derFile, $result);
       for($i = 1; $i < count($result); $i++) {
          echo "$result[$i]\n";
       }
    }
    echo "</div>
    </div></pre>\n";

    break;

      
   // En este caso se procede a la descarga del certificado 
   case "crt_download":
      $crtFileName = $crtWeb . $crtFileName;
      echo "<iframe frameborder='0' name='cert' width='1' height='1' src='$crtFileName'></iframe><h2>Certificado descargado</h2><p>Su certificado ha sido instalado en su navegador si est&aacute; utilizando <b>el mismo navegador desde el que solicit&oacute; la petici&oacute;n de certificado.</b></p>
      <p>Por favor, compruebe en las preferencias de su navegador si el certificado se encuentra instalado en la base de datos de certificados personales</p>";
      $status = "download";
      $user = "Publico";
      writeLog($status, $crt_copa, $user, $errorNumber);
      
   break;

}

pie ();

?>
