<?php


require "/home/masa/rediris/pkiris/src/0.8.0b/pkIRIS-CA/etc/pkIRIS/pkIRIS.conf";


###############################################################################
#                                                                             #
# Library File for pkIRIS                                                     #
#                                                                             #
###############################################################################


################################### FUNCTIONS #################################


#
# function checkAuth: 
#
function checkAuth($place) {
   global $base;
   global $rdn1;
   global $authMethod;
   global $confDir; 

   session_start();
   if (!isset($_SESSION['user'])) {
      echo("<script type=\"text/javascript\">
      //<![CDATA[
      alert(\"No se ha autenticado, por favor introduzca su usuario y password.\");
      location.href='/';
      //]]>
      </script>");
   }
   else {
      // Obtenemos el pkirisCopaID a partir de pkirisSubjectID
      $user=$_SESSION['user'];
      switch ( $authMethod ) {
         case "ldap":		 
            if ($user == getIdFromDN(getDn())) {
               $info = getPermFromDN(getDn());
               for( $i=0; $i < count($info[0]['irisuserentitlement']); $i++ ) {
                  list($k1,$k2,$k3,$k4,$k5,$attr,$value)=split(":",$info[0]['irisuserentitlement'][$i]);
                  if (($place == $attr)&&($value=="admin")) {
	             $rights="true";   
                  }
               }
               if ($rights!="true") {
                  echo("<script type=\"text/javascript\">
                  //<![CDATA[
                  alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
		  location.href='/';
                  //]]>
                  </script>");
               }
            }
            else {
               session_start();
               session_unset();
               session_destroy();
        
               echo("<script type=\"text/javascript\">
               //<![CDATA[
               alert(\"El certificado que ha elegido no pertenece a el usuario con el que ha hecho login.\");
               location.href='/';
               //]]>
               </script>");
            }
	 break;
	 case "plainCc":
            if ($user == getIdFromDN(getDn())) {
		    echo "PASO";
	       $permFile = fopen ($confDir . "perm", "r"); // Poner como variable global
               $buf2 = fgets ($permFile);
               $rights=0;
               while ((!$rights)&&(!feof($permFile))) {
	          list ($userFile, $urnFile) = split (";", $buf2);
	          if ($user == $userFile) {
		     list($k1,$k2,$k3,$k4,$k5,$placeFile,$k7)=split(":",$urnFile);
		     if ($place == $placeFile) {
	                $rights=1;
		     }
		  }
	          $buf2 = fgets($permFile);
               }  
               fclose ($permFile);
               if (!$rights) {
	          echo("<script type=\"text/javascript\">
                  //<![CDATA[
	          alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
	          location.href='/';
                  //]]>
                  </script>");
               }
	    }   
            else {
	       session_start();
               session_unset();
               session_destroy();
	
               echo("<script type=\"text/javascript\">
               //<![CDATA[
               alert(\"El certificado que ha elegido no pertenece a el usuario con el que ha hecho login.\");
               location.href='/';
               //]]>
               </script>");
            }
         break;
	 case "plainSc":
	    $permFile = fopen ($confDir . "perm", "r"); // Poner como variable global
	    $buf2 = fgets ($permFile);
	    $rights=0;
	    while ((!$rights)&&(!feof($permFile))) {
	      list ($userFile, $urnFile) = split (";", $buf2);
	      if ($user == $userFile) {
		list($k1,$k2,$k3,$k4,$k5,$placeFile,$k7)=split(":",$urnFile);
		if ($place == $placeFile) {
		   $rights=1;   
		}
	      }
	      $buf2 = fgets($permFile);
	    }
	    fclose ($permFile);
	    if (!$rights) {
	       echo("<script type=\"text/javascript\">
	       //<![CDATA[
	       alert(\"Su usuario no tiene suficientes permisos para acceder a esta zona.\");
	       location.href='/';
	       //]]>
	       </script>");
	    }
         break;
      }   
   }
}
				  

#
# function cabecera: anyade al codigo desde el que se invoca la funcion el
# menu con las opciones disponibles. Este menu variara dependiendo del valor
# de '$idCabecera'. Tambien anyade informacion como el titulo de la pagina
# o el logo de la organizacion entre otras cosas. Normalmente se llamara al 
# principio del codigo, mostrando la informacion a modo de cabecera de pagina.
#
function cabecera($idCabecera) {
   global $pkiUrl;
   global $menu;
   global $raPublicDir; 
   global $raAdminDir;
   global $base;
   global $rdn1;
   global $authMethod;

   $tabText = "pkIRIS";
   echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN'
   'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>
    <html xmlns='http://www.w3.org/1999/xhtml' xml:lang='es'>
    <head>
       <meta http-equiv='content-type' content='text/html;charset=utf-8' />
       <link rel='shortcut icon' href='../images/favicon.ico' />
       <title>CICA | Infraestructura de Clave P&uacute;blica</title>
       <style type='text/css' media='all'>@import '/styles/pkiris.css';</style>
    </head>\n";

   echo "<body#pkiris>
   <div id='container'>
      <div id='pkHeader'>
         <img alt='logo' src='/images/lg-cica-02.png'>
	 <div id='galipollo'>
	    <img alt='galipollo' src='/images/pkiris-galipollo-logo.png'>
	 </div> <!-- galipollo -->
      </div> <!-- pkHeader -->
      <div id='nav'>
         <ul>
         <li><a href='$pkiUrl' title='Home'>Home</a></li>\n";
   
      // El valor de $idCabecera nos indicara la seccion donde estemos, y 
      // segun cual sea mostraremos una informacion u otra	      
      switch($idCabecera) {
         case 1: // Seccion de usuarios de la RA
            $tabText = "Usuarios";
            echo "<li><a href='".$raAdminDir."' title='Administraci&oacute;n de la RA'>Administraci&oacute;n</a></li>
            <li><a href='".$raPublicDir."' title='Usuarios de la RA'>Usuarios</a></li>";
	    break;
         case 2: // Seccion de administracion de la RA
            $tabText = "Admin RA";
            echo "<li><a href='".$raAdminDir."' title='Administraci&oacute;n de la RA'>Administraci&oacute;n</a></li>
            <li><a href='".$raPublicDir."' title='Usuarios de la RA'>Usuarios</a></li>";
            $dn = getDn();
            echo "</ul>
            <div id='nav_user'>\n";
	    // Buscamos la informacion del usuario para presentar su informacion

	    $filter = "(&(objectClass=pkirisCertificate)(pkirisSubjectDn=$dn)(pkirisStatus=issued))";
	    $error = 0;
	    $justthese = array("$rdn1");
	    $result = ldap_get_info($base, $filter, $justthese);
	    if (!$result){
              $error = 69;
              echo "Usuario: Desconocido";
            }
	    else {
	       $eeCopa = $result[0][$rdn1][0];
	       list($eeCopa, $kk) = split("c",$eeCopa);	
               $filter = "(&(objectClass=pkirisEndEntity)($rdn1=$eeCopa))";
               $error = 0;
	       $justthese = array("cn", "sn");
	       $result = ldap_get_info($base, $filter, $justthese);

	       if (!$result){
                  $error = 69;
                  echo "Usuario: Desconocido";
               }
	       else {
	          echo "Usuario: ".$result[0]["cn"][0]. " " . $result[0]["sn"][0];
	       }
	    }
	    
            echo "</div>";
	    break;
         case 3: // Seccion de administracion de la pkIRIS
            $tabText = "Admin PKI";
            break;	    
	 case 4: // Seccion de la CA
	    $tabText = "CA"; 
	    break;
         case 5: // Seccion de Operadores de la CA
            $tabText = "Operaciones CA";
            break;
      }	 

      echo "</div>
      <div id='nav_sombra'></div>
       </ul>
       <div id='pkBody'>
         <div id='sidebar'>

       <div id='tbox'>
       <h3 class='head_a1b1'>$tabText</h3>
        <ul>\n";
															       
   while (list ($index, $content) = each ($menu[$idCabecera])) {
      echo "<li><a href='$index'>$content</a></li>";
   }
   echo "</ul>
      </div>\n";
/*
   echo "</ul>
      </div> <!--tbox menu-->
      <!-- Ini: Login -->
      <div id='tbox'>
         <h3 class='head_a1b1'>Login</h3>\n";
	 if (!isset($_SESSION['user'])) {
            echo"<form action='/auth.php' method='post'>
               <div id='tbox_data_a1b1'>
                  Usuario<br/>
                  <input type='text' name='user' size='23' /><br/>
                  Clave<br/>
		  <input type='password' name='passwd' size='23' /><br />
                  <input class='button' type='submit' name='boton1' value='Entrar' />
               </div>
            </div>
	    <!-- End: Login -->
	    </form>\n";
	 }
	 else {
            echo"<div id='tbox_data_a1'>
	    Bienvenid@<br/>\n";
	    $user=$_SESSION['user'];
	    $filter = "(&(objectClass=pkirisEndEntity)(pkirisID=$user))";
	    $error = 0;
	    $justthese = array("cn", "sn");
	    $result = ldap_get_info($base, $filter, $justthese);
	    if (!$result){
	       $error = 69;
	       echo "Desconocido<br/>";
            }
	    else {
               echo $result[0]["cn"][0]. " " . $result[0]["sn"][0]."<br/>";
	    }
	    echo "<a href='/close_session.php'>Cerrar sesi&oacute;n</a><br/>
	    </div>\n";
	 }
      echo"</div> <!-- tbox login -->
*/
    echo "
    </div><!--sidebar-->
    <div id='content'>\n";
}

#
# function pie: anyade informacion al codigo desde el que se invoca a la 
# funcion. Normalmente esta funcion se llamara al final del codigo, a modo de
# pie de pagina.
#
function pie() {
   echo "</div> <!-- content -->
   </div> <!-- pkBody -->\n
   <div id=\"ie_fix_01\"><!-- Mamoneo IE --></div>\n
   <div id='pkFooter'>
      <div id='credits'>
         pkIRIS 2006
      </div> <!-- credits -->
      <div id='url'>
         RedIRIS - CICA
      </div> <!-- url -->
   </div> <!-- pkFooter -->
   </div> <!-- container -->
</body>
</html>\n";
				 
}

#
# function ldap_get_info: Obtiene solo la informacion indicada por $justthese 
# de la entrada ldap correspondiente a $baseDn, con el filtro $filter
#
function ldap_get_info($baseDn, $filter, $justthese) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;

   $retValue = false;	
   $ds=ldap_connect($ldapServer, $ldapServerPort);

   if ($ds) {
      // bind with appropriate dn to give update access
      $r=ldap_bind($ds, $ldapAdmin, $ldapAdmPass);
      if(!$r) die("ldap_bind failed<br>");
      $rs=ldap_search($ds, $baseDn, $filter, $justthese);
      $info=ldap_get_entries($ds, $rs);
      $num=$info["count"];
      ldap_close($ds);
      if ($num != 0)
         $retValue = $info;
   } 
   else 
      echo "Unable to connect to LDAP server";
   
   return $retValue;
}

#
# function ldap_get_cert: Obtiene el certificado indicado por $baseDn
#
function ldap_get_cert($baseDn, $filter) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;

   $retValue = false;
   $ds=ldap_connect($ldapServer, $ldapServerPort);

   if ($ds) {
      // bind with appropriate dn to give update access
      $r=ldap_bind($ds, $ldapAdmin, $ldapAdmPass);
      if(!$r) 
         echo "ldap_bind failed<br>";
      else {
         $justthese = array("usercertificate");      
         $rs=ldap_search($ds, $baseDn, $filter, $justthese);
         if (!$rs)
            echo "ldap_search failed<br>";
         else {   
            $info=ldap_get_entries($ds, $rs);
            $entry = ldap_first_entry($ds, $rs);
            // Esto se hace porque como el certificado esta en binario en el ldap 
            // tenemos que traerlo con esta funcion si no no lo lee bien
            $retValue = ldap_get_values_len($ds, $entry, "userCertificate;binary");
            if (!$retValue)
	       echo "ldap_get_values failed<br>";
         }
         ldap_close($ds);
      }
   }
   else 
      echo "Unable to connect to LDAP server";

   return $retValue;
}

#
# function ldap_mod_info: Modifica una solicitud existente indicada por $dn 
# con la informacion contenida en $info
#
function ldap_mod_info($dn, $info) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;

   $retValue = false;
   $ds=ldap_connect($ldapServer, $ldapServerPort);
   if ($ds) {
      $r=ldap_bind($ds, $ldapAdmin, $ldapAdmPass);
      if(!$r) 
         echo "ldap_bind failed<br>";
      else {
         $retValue = ldap_modify($ds, $dn, $info);
	 if ( !$retValue ) 
	    echo "ldap_modify failed<br>";
      }
      ldap_close($ds);	
   }   
   else
      echo "Unable to connect to LDAP server";   

   return $retValue;
}

#
# function ldap_mod_add_info: Anyade informacion a una solicitud ya existente
#
function ldap_mod_add_info($dn, $info) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;
	
   $retValue = false;
   $ds=ldap_connect($ldapServer, $ldapServerPort);
   if ($ds) {
      $r=ldap_bind($ds, $ldapAdmin, $ldapAdmPass);
      if(!$r) 
         echo "ldap_bind failed<br>";
      else {
         $retValue = ldap_mod_add($ds, $dn, $info);
	 if ( !$retValue )
	    echo "ldap_mod_add failed<br>";
      }
      ldap_close($ds);
   }
   else
      echo "Unable to connect to LDAP server";
  
   return $retValue;
}

#
# function ldap_add_info: Anyade informacion a una nueva solicitud
#
function ldap_add_info($dn, $info) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;

   $retValue = false;
   $ds=ldap_connect($ldapServer, $ldapServerPort);
   if ($ds) {
      $r = ldap_bind($ds, $ldapAdmin, $ldapAdmPass);      
      if(!$r) 
         echo "ldap_bind failed<br>";
      else {
         $retValue = ldap_add($ds, $dn, $info);
	 if ( !$retValue )
	    echo "ldap_add failed<br>";
      }	    
      ldap_close($ds);
   }
   else
      echo "Unable to connect to LDAP server";
		    
   return $retValue;
}

#
# function ldap_del_record: borra una entrada indicada mediante el dn del servicio de directorio
#

function ldap_del_record($dn) {
   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;

   $retValue = false;
   $ds=ldap_connect($ldapServer, $ldapServerPort);
   if ($ds) {
      $r=ldap_bind($ds, $ldapAdmin, $ldapAdmPass);
      if(!$r) 
         echo "ldap_bind failed<br>";
      else {
         $retValue = ldap_delete($ds, $dn);
         if ( !$retValue )
            echo "ldap_add failed<br>";
      }
      ldap_close($ds);
   }
   else
      echo "Unable to connect to LDAP server";
   
   return $retValue;
}

#
# function getStatus: Devuelve el estado de la solicitud indicada por su 
# numero copa.
#
function getStatus($copa) {

   global $ldapServer;
   global $ldapServerPort;
   global $ldapAdmin;
   global $ldapAdmPass;
   global $base;
   global $rdn1;
   
   $retValue = false;
   // Obtenemos el estado de la solicitud
   $filter = "(&(objectclass=pkirisCertificate)($rdn1=$copa))";
   $justthese = array ("pkirisstatus");
   $rs = ldap_get_info($base, $filter, $justthese);
   if ( $rs ) 
      $retValue = $rs[0]["pkirisstatus"][0];
      
   return $retValue;
}

#
# function changeStatus: Esta funcion cambia el estado de la solicitud indicada
# por $copa
#
function changeStatus($copa, $status) {

   global $base;

   $retValue = false;
   // Comprobamos si $status contiene un valor valido	
   if ($status=="new" OR $status=="renew" OR $status=="issued" OR $status=="approved" OR $status=="ra2ca" OR $status=="csr-refused" OR $status=="rnr-refused" OR $status=="crr-refused" OR $status=="csr-denied" OR $status=="rnr-denied" OR $status=="revoke" OR $status=="revoked-ca" OR $status=="revoked-ra" OR $status=="revoked-usr" OR $status=="ca2ra" OR $status=="csr-pending" OR $status=="rnr-pending" OR $status=="crr-pending" OR $status=="csr-deferred" OR $status=="rnr-deferred" OR $status=="crr-deferred" OR $status=="error" ) {	   
      $newStatus["pkirisstatus"] = "$status";
      $dn = "$rdn1=$copa," . $base;
      $retValue = ldap_mod_info($dn, $newStatus);      
    }

   else{
      echo "Error: El estado no es valido. Los estados posibles son: new, renew, issued, approved, ra2ca, csr-refused, rnr-refused, crr-refused, csr-denied, rnr-denied, revoke, revoked-ra, revoked-ca, revoked-usr, ca2ra, csr-pending, rnr-pending, crr-pending, csr-deferred, rnr-deferred, crr-deferred y error.<br>";
   }      

   return $retValue;
}

#
# function writeLog: writes in a log file the action ($action) done  
# for the user ($user). Also writes date, copa number and error code
#
function writeLog ($action, $copa, $user, $error) {

   global $log;

   $retValue = false;
   // Abrimos el fichero de log para anyadirle una nueva linea
   $fd = fopen ($log, "a");
   if (!$fd) 
      echo "Cannot open " . $log;
   else {
      $action = sprintf("%-15s", $action);	  
      $copa = sprintf ("%-9s", $copa);

      if ($error == 0)
         $retValue = fwrite ($fd, "\n" . date("Ymd H:i:s") . " [" . $action. "] eee=" . $copa. " usr=" . $user);      
      else
         $retValue = fwrite ($fd, "\n" . date("Ymd H:i:s") . " [" . $action. "] eee=" . $copa. " usr=" . $user. " err=" . $error);
   } 
   
   fclose ($fd);

   return $retValue;
}

#
# function getDn: return the distinguish name of the certificate that you have
# used to validate to the aplication. In other case return false.
#
function getDn () {

   $retValue = false;
   
   if ( isset($_SERVER["SSL_CLIENT_S_DN"]) ) {
      $arrayDn=split("/",$_SERVER["SSL_CLIENT_S_DN"]);
      for ($i = 1; $i < count($arrayDn); $i++ ) {
         if ($i == 1)  		 
	    $retValue = strtolower($arrayDn[$i]);
	 else
            $retValue = $retValue .",". strtolower($arrayDn[$i]);
      }
   }
   return $retValue;
}

#
# function getPassFromDN: return an array with three fields. First with the 
# distinguish name, the second with the common name and the last one with the 
# surname. This function was created for the authentication process.
#
function getPermFromDN($dn) { 
   global $base;
   global $rdn1;

   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(|(pkirisStatus=issued)(pkirisStatus=revoke)(pkirisStatus=ra2ca)))";
   $justthese = array($rdn1);
   $result = ldap_get_info($base,$filter,$justthese);
   $id = $result[0][$rdn1][0];
   list($ab,$c)=split("c",$id);

   // With the value of pkirisID we make another search for the username, 
   // lastname and password.
   $filter = "(&(objectclass=pkirisEndEntity)($rdn1=$ab))";
   $justthese = array("dn","cn","sn","irisuserentitlement");
   $retValue = ldap_get_info($base,$filter,$justthese);
   
   return $retValue;
}

#
# function getUserCopaFromDN: return the user copa number from SubjectDN. 
# This function was created for the revocation process.
#
function getUserCopaFromDN($dn) {
   global $base;
   global $rdn1;

   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(pkirisStatus=issued))";
   $justthese = array($rdn1);
   $result = ldap_get_info($base,$filter,$justthese);
   if ( $result != false ) {
      $id = $result[0][$rdn1][0];
      list($retValue,$c)=split("c",$id);
   }   
   return $retValue;
}

#
# function getIdFromDN: return the user ID from SubjectDN.
#
			     
function getIdFromDN($dn) {
   global $base;
   global $rdn1;
   $retValue = false;
   // We search for pkirisID.
   $filter = "(&(objectclass=pkirisCertificate)(pkirisSubjectDN=$dn)(|(pkirisStatus=issued)(pkirisStatus=revoke)(pkirisStatus=ra2ca)))";
   $justthese = array("pkirisID");
   $result = ldap_get_info($base,$filter,$justthese);
   $id = $result[0]["pkirisid"][0];
   return $id;
}
						     
#
# function incrCounter: increases the pkiriscounter of the user or csr 
# which copa code is $copa.
#
function incrCounter($copa){
   global $base;
   global $rdn1;

   $retValue = false;
   $filter = ("$rdn1=$copa"); 
   $dn = "$rdn1=$copa,$base";
   $justthese = array ("pkiriscounter");

   $userCount = ldap_get_info($dn,$filter,$justthese);
   $incrUsr["pkiriscounter"] = $userCount[0]["pkiriscounter"][0] + 1;
   $retValue = ldap_mod_info($dn, $incrUsr);
   
   return $retValue;			       
}

#
# function getCounter: return the pkirisCounter.
#
function getCounter($copa){
   global $base;   	
   global $rdn1;
   
   $retValue = false;
   $filter = ("$rdn1=$copa");
   $dn = "$rdn1=$copa,$base";
   $justthese = array ("pkiriscounter");

   $userCount = ldap_get_info($dn,$filter,$justthese);
   if ( $userCount != false )
      $retValue = $userCount[0]["pkiriscounter"][0];
      
   return $retValue;	
}

#
# function getMail: return the e-mail address of the user whose copa code is $copa.
#
function getMail($copa){
  global $base;	
  global $rdn1;
  
  $retValue = false;
  list($copaUsr,$c)=split("c",$copa);
  $filter = "(&(objectclass=pkirisEndEntity)($rdn1=$copaUsr))";
  $dn = "$rdn1=$copaUsr,$base";
  $justthese = array ("mail");

  $userMail = ldap_get_info($dn,$filter,$justthese);
  if ( $userMail != false )
     $retValue = $userMail[0]["mail"][0];     
	  
  return $retValue;
}

#
# function getNavType: return the navigator type of the CSR which copa code is $copa
#
function getNavType($copa){
   global $base;
   global $rdn1;
   
   $retValue = false;
   $filter = ("$rdn1=$copa");
   $dn = "$rdn1=$copa,$base";   
   $justthese = array ("pkiriscsr");

   $csr = ldap_get_info($dn,$filter,$justthese);

   if ( $csr != false ) {
      // comparamos 5 primeros caracteres de la CSR, suficientes para identificar 
      // el tipo de navegador que se utilizo al generar la solicitud
      if ( strncmp($csr[0]["pkiriscsr"][0], "SPKAC", 5) == 0 )
         $retValue = "SPKAC";
      else
         $retValue = "IE";
   }
   return $retValue;
}

#
# function getBrowser: devuelve el tipe de navegador desde el que se esta 
# realizando la solicitud
#
function getBrowser( ) 
{
  $retValue = false;
  $browser_number = '';
  // get userAgent string
  $browser_user_agent = ( isset( $_SERVER['HTTP_USER_AGENT'] ) ) ? strtolower( $_SERVER['HTTP_USER_AGENT'] ) : '';
  //pack browser array
  // values [0]= user agent identifier, lowercase, [1] = dom browser, [2] = shorthand for browser,
  $a_browser_types[] = array('opera', true, 'op' );
  $a_browser_types[] = array('msie', true, 'ie' );
  $a_browser_types[] = array('konqueror', true, 'konq' );
  $a_browser_types[] = array('safari', true, 'saf' );
  $a_browser_types[] = array('gecko', true, 'moz' );

  for ($i = 0; $i < count($a_browser_types); $i++) {
     $s_browser = $a_browser_types[$i][0];
     $b_dom = $a_browser_types[$i][1];
     $retValue = $a_browser_types[$i][2];
     // if the string identifier is found in the string
     if (stristr($browser_user_agent, $s_browser)) {
     // we are in this case actually searching for the 'rv' string, not the gecko string
     // this test will fail on Galeon, since it has no rv number. You can change this to 
     // searching for 'gecko' if you want, that will return the release date of the browser
     if ( $retValue == 'moz' )
        $s_browser = 'rv';
       
     break;
     }
  }
  return $retValue;
}  

#
# function getTrace: create and return a valid pkirisTrace. 
#
function getTrace ($traceVals) { 
   global $pkirisTracePrefix;
   global $raPrivKey;
 
   // Si no esta definida la variable global que contiene la clave
   // privada de la RA '$raPrivKey', necesitamos obtenerla del fichero
   // de claves (este caso solo debe cumplirse en la CA) o del propio
   // fichero de configuracion de la RA (para algunas operaciones en la RA)
   if ( !isset($raPrivKey) ) {
      // Nos quedamos con el numero de ra ('ai') del copa
      list ($raCopa, $k) = split ("b", $traceVals["copa"]);
      $raPrivKey = getRaPrivKey($raCopa);
      if ( !$raPrivKey ) {
         $errorDescription = $errorDescription . "\n<p>No ha sido posible obtener la clave privada de la RA. Asegurese de que existe una clave valida para la RA. \n</p>";
         $errorCode = "69";
         $errorCounter++;
      }
   }
   
   $retValue = false; 
   $status = $traceVals["status"];

   // Le anyadimos el prefijo, la fecha y el estado a la traza
   $pkirisTrace = $pkirisTracePrefix . ":csr:state:".$traceVals["currentDate"].":$status";

   $comments = $traceVals["comments"];

   // Si hay comentarios, le tenemos que anyadir el punto y coma y 'comment='
   // al principio. Ademas, si hubiese algun ';' en el comentario, lo 
   // sustituimos por su codigo ascii (%59) para evitar comflictos
   if ($comments != '')
      $comments = ";comment=". str_replace(";","%59", $comments);
    
   // Dependiendo del estado, le anyadiremos unos valores u otros a la traza

   // En caso de error le anyadimos su codigo y los comentarios
   if ($status == "error")
      $pkirisTrace = $pkirisTrace . ";level=".$traceVals["level"].";invalidityDate=".$traceVals["invalidityDate"]."$comments";
      
   // Le anyadimos el motivo de revocacion, la fecha de invalidez y comentarios
   else if ( $status == "revoke" || $status == "crr-pending" || strstr($status,"revoked-") )
      $pkirisTrace = $pkirisTrace . ";reason=".$traceVals["revocationReason"].";invalidityDate=".$traceVals["invalidityDate"]."$comments";

   // En este caso solo le anyadiremos los comentarios (en caso de existir)      
   else if ( $status == "approved" || strstr($status,"-denied") || strstr($status,"-refused") || strstr($status,"-deferred") )
      $pkirisTrace = $pkirisTrace . $comments;
   
   // Le anyadimos la firma al final de la traza
   $retValue = $pkirisTrace . ":" . sha1($pkirisTrace.$raPrivKey.$traceVals["copa"]);

   return $retValue;   
}

#
# function getLastComment: return the last comments of the pkirisTraces
#
function getLastComment ($copa) {

   global $base;
   global $rdn1;
   global $pkirisTracePrefix;
   global $traceIndices;   

   $retValue = false;
   $lastDate = 0;
   $filter = "(&(objectClass=pkirisCertificate)($rdn1=$copa))";
   $dn = "$rdn1=$copa,$base";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud con numero copa indicado por $copa
   $pkirisTraces = ldap_get_info($dn,$filter,$justthese);

   while (list($index, $value) = each($pkirisTraces[0]["pkiristrace"])) {
      // Parseamos la traza por el prefijo $pkirisTracePrefix
      list($k, $tmp) = split($pkirisTracePrefix, $value);
      // y metemos en un array el resto de componentes de la traza
      $tr = split(":", $tmp);
      // Le quitamos el primer elemento porque no contiene nada
      array_shift ($tr);
      // En traceIndices['status'] se encuentra el indice correspondiente al 
      // campo que contiene el estado de la traza (0, 1 ... n), y en
      // traceIndices['date'] el de la fecha
      $tmpStatus = $tr[$traceIndices['status']];
      list($k, $comment) = split ("comment=", $tmpStatus);

      $date = $tr[$traceIndices['date']];
      
      if ( ($date > $lastDate) && ($comment != '') ) {
         $lastDate = $date;
	 $retValue = str_replace("%59", ";", $comment);
      }
   }
   
   return $retValue;
}

#
# function getTracesFromStatus: devuelve un array con las trazas anyadidas
# al ldap desde la que tiene estado $status (inclusive) hasta la ultima, 
# ordenadas por fecha.
#
function getTracesFromStatus ($copa, $status) {
   global $base;
   global $rdn1;
   global $pkirisTracePrefix;
   global $traceIndices;

   $retValue = false;   
   $filter = ("$rdn1=$copa");
   $dn = "$rdn1=$copa,$base";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud con numero copa indicado por $copa
   $result = ldap_get_info($dn,$filter,$justthese);

   $pkirisTraces = $result[0]["pkiristrace"];
   // Ordenamos el array de trazas. Debido a su estructura, se ordena por fecha
   sort($pkirisTraces);

   $lastStatusFound = -1;
   // En el siguiente array sera el que devolveremos
   $arrayTraces = array();

   while (list($index, $value) = each($pkirisTraces)) {
      // Parseamos la traza por el prefijo $pkirisTracePrefix
      list($k, $tmp) = split($pkirisTracePrefix, $value);
      // y metemos en un array el resto de componentes de la traza
      $tr = split(":", $tmp);
      // Le quitamos el primer elemento porque no contiene nada
      array_shift ($tr);			
      
      // En traceIndices['status'] se encuentra el indice correspondiente al
      // campo que contiene el estado de la traza (0, 1 ... n)
      $tmpStatus = $tr[$traceIndices['status']];
      list($traceStatus, $k) = split (";", $tmpStatus);
     
      // Si es igual al estado que estamos buscando, nos quedamos con el
      // indice del array
      if ( $traceStatus == $status ) 
         $lastStatusFound = $index;	 
   }

   if ($lastStatusFound != -1) {
      // Recorremos el array $pkirisTraces desde el elemento indicado por
      // $lastStatusFound y guardamos las trazas en el array $arrayTraces
      for ($i = $lastStatusFound ; $i < count ($pkirisTraces) - 1 ; $i++)
         array_push($arrayTraces, $pkirisTraces[$i]);
      $retValue = $arrayTraces;
   }
   
   return $retValue;
}

#
# function renewalsCounter: devuelve el numero de certificados renovados que ha
# tenido el usuario con codigo copa indicado por $copa 
#
function renewalsCounter($copa) {
   global $base;
   global $rdn1;
   global $pkirisTracePrefix;
   global $traceIndices;

   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa*))";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de todas las solicitudes del usuario indicado por $copa
   $pkirisTraces = ldap_get_info($base,$filter,$justthese);
   $renewalsNumber = 0;
   $end = false;
  
   // Ordenamos la matriz en orden inverso. Incrementaremos el contador
   // cuando se encuentre una traza a renew, y pararemos de contar cuando
   // encuentre una a new. De este modo obtenemos el numero de renovaciones
   // del usuario desde la ultima vez que hizo una nueva solicitud ('new')
   arsort($pkirisTraces);
   // Recorremos todos las solicitudes
   while (list($index) = each($pkirisTraces) AND !$end) {
      $isIssued = false;  
      $isRenewed = false;       
      if  ($index != "count") { 
         // Para cada solicitud, recorremos todas sus trazas
         while (list(,$trace) = each($pkirisTraces[$index]['pkiristrace'])) {
            // Parseamos la traza por el prefijo $pkirisTracePrefix
            list($k, $tmp) = split($pkirisTracePrefix, $trace);
	    // y metemos en un array el resto de componentes de la traza
	    $tr = split(":", $tmp);
	    // Le quitamos el primer elemento porque no contiene nada
	    array_shift ($tr);
	    
            // En traceIndices['status'] se encuentra el indice correspondiente al
	    // campo que contiene el estado de la traza (0, 1 ... n)
	    $tmpStatus = $tr[$traceIndices['status']];
	    list($traceStatus, $k) = split (";", $tmpStatus);
	    
	    if ($traceStatus == "issued")
	       $isIssued = true;

   	    if ($traceStatus == "renew")
	       $isRenewed = true; 

	    if ($traceStatus == "new")
	       $end = true;
         }
      }
      // Solo si la solicitud ha sido firmada y renovada en algun momento, 
      // incrementaremos el contador
      if ($isIssued AND $isRenewed)
         $renewalsNumber++;
   }
   return $renewalsNumber;
}

#
# function getRequestTypeFromTraces: Obtiene el tipo de la solicitud $copa
# que estemos tratando (csr o rnr). Comprueba si la primera traza es new (csr) 
# o renew (rnr). 
#
function getRequestTypeFromTraces($copa) {
   global $base;
   global $pkirisTracePrefix;
   global $traceIndices;
   
   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
   $justthese = array ("pkiristrace");
   // Obtenemos todas las trazas de la solicitud indicada por $copa,
   $pkirisTraces = ldap_get_info($base,$filter,$justthese);
   // las ordenamos
   sort($pkirisTraces);
   // y nos quedamos con el estado de la primera traza. Al estar ordenadas por 
   // fecha, la primera traza tiene que tener estado 'new' o 'renew' (si no ha
   // habido ningun error en algun proceso).
   $firstTrace = $pkirisTraces[1]['pkiristrace'][0]; // primera traza del array
   // Parseamos la traza por el prefijo $pkirisTracePrefix
   list($k, $tmp) = split($pkirisTracePrefix, $firstTrace);
   // y metemos en un array el resto de componentes de la traza
   $tr = split(":", $tmp);
   // Le quitamos el primer elemento porque no contiene nada
   array_shift ($tr);
   
   // Obtenemos el estado
   $tmpStatus = $tr[$traceIndices['status']];
   list($traceStatus, $k) = split (";", $tmpStatus);
   
   if ($traceStatus == "new")
      $requestType = "csr";
   else if ($traceStatus == "renew")
      $requestType = "rnr";
   else
      $requestType = "error";
      
   return $requestType;  
}

#
# function parseXML: construye y devuelve un array con todos los tags del 
# codigo XML correspondiente al fichero de entrada. Sera un array multivaluado 
# indexado por el numero de solicitud dentro del fichero, seguido del nombre 
# del tag y su valor. La posicion '0' esta reservada para informacion del 
# propio fichero. Si hay algun error, devuelve 'false'.
#
function parseXML ($xmlFile) {
   global $raPrivKey;
   global $caPrivKey;
   global $isCA; 
   global $pkirisTracePrefix;
   global $traceIndices; 
   
   // Creamos un array con las expresiones regulares que parsearemos
   // el fichero XML.
   
   // Expresiones comunes a todos los tipos de XML
   $regex['pki'] = "/<pki type=(.*) version=.*>\n(.*?)\n<\/pki>/ms";
   $regex['header'] = "/<header>(.*?)<\/header>/ms";
   $regex['data'] = "/<data>(.*?)<\/data>/ms";
   $regex['sig'] = "/<sig>(.*?)<\/sig>/";
   $regex['total_sig'] = "/<total_sig>(.*)?<\/total_sig>/";
   
   $regex['dn'] = "/<dn>(.*?)<\/dn>/";
   $regex['id'] = "/<id>(.*?)<\/id>/";
   $regex['copa_id'] = "/<copa_id>(.*?)<\/copa_id>/";
   $regex['traces'] = "/<traces>(.*?)<\/traces>/ms";
   $regex['traceurn']= "/<trace>(urn:mace:rediris.es:.+:.+:csr:state:.+:.+:.+)<\/trace>/";
   
   $regex['csrs_file'] = "/.*[\/*]csr_r(.*)d(....)(..)(..)t(.*)\.xml/";
   
   // Leemos el fichero con las solicitudes y los pasamos a una cadena
   $xmlContent = file_get_contents($xmlFile);
   
   if ( $xmlContent == false ) {
      $errorNumber = 69;
      $errorCounter++;
   }
   else {
      // Metemos en un array las lineas de la cadena que cumplen la expresion 
      // regular
      $r = preg_match($regex['csrs_file'], $xmlFile, $xmlInfo['fileInfo']);
      list ($k, $ra, $dY, $dM, $dD, $time) = $xmlInfo['fileInfo'];
      $wDir = "$dY/$dY$dM/$dY$dM$dD/r$ra"."d$dY$dM$dD"."t$time";               

      // En el array $arrayData guardaremos la informacion de todas las 
      // solicitudes incluidas en el fichero
      $arrayData[0]['wDir'] = $wDir;

      // Obtenemos el tipo de XML y lo guardamos en arrayData
      $r = preg_match($regex['pki'], $xmlContent, $xmlInfo['pki']);
      $xmlType = $xmlInfo['pki'][1];
      $arrayData[0]['xmlType'] = $xmlType;
     
      // CSRs 
      if ( $xmlType == '"csr"') {
	 // Expresiones regulares que nos serviran para obtener la informacion
	 // de los ficheros que contengan solicitudes de certificados
         $regex['requests_type'] = "/(<csrs>.*?<\/csrs>)/ms";
         $regex['request_type'] = "/<(csr|rnr)>(.*?)<\/csr|rnr>/ms";
	 $regex['nav_type'] = "/<nav_type>(.*?)<\/nav_type>/";
	 $regex['ee_type'] = "/<ee_type>(.*?)<\/ee_type>/";
	 $regex['mail'] = "/<mail>(.*?)<\/mail>/";
	 $regex['show_mail'] = "/<show_mail>(.*?)<\/show_mail>/";
	 $regex['subject_dn'] = "/<subject_dn>(.*?)<\/subject_dn>/";
      }
      
      // CRRs
      else if ($xmlType == '"crr"') {
	 // Expresiones regulares que nos serviran para obtener la informacion
         // de los ficheros que contengan solicitudes de revocacion 
	 $regex['request_type'] = "/<(crr)>(.*?)<\/crr>/ms";
	 $regex['serial'] = "/<serial>(.*?)<\/serial>/";
	 $regex['revoked_by'] = "/<revoked_by>(.*?)<\/revoked_by>/";
	 $regex['reason'] = "/<reason>(.*?)<\/reason>/";
	 $regex['invalidity_date'] = "/<invalidity_date>(.*?)<\/invalidity_date>/";
      }
      
      // CRTs y RVKs
      else if ( $xmlType == '"crt"' )  {
	 // Expresiones regulares que nos serviran para obtener la informacion
         // de los ficheros que contengan tanto certificados como revocaciones 
	 // de los mismos
	 $regex['requests_type'] = "/(<crt2ra>.*?<\/crt2ra>)/ms";
	 $regex['request_type'] = "/<(crt|rvk|rfd)>(.*?)<\/(crt|rvk|rfd)>/ms"; 
	 $regex['status'] = "/<status>(.*?)<\/status>/";
	 $regex['expiration_date'] = "/<expiration_date>(.*?)<\/expiration_date>/";
	 $regex['date'] = "/<date>(.*?)<\/date>/";
      }

      // PRIVATE (XML con la clave privada de la RA)
      else if ( $xmlType == '"private"' ) {
         $regex['request_type'] = "/<(private)>(.*?)<\/(private)>/ms";
	 $regex['private_key'] = "/<private_key>(.*?)<\/private_key>/";
	 $regex['date'] = "/<date>(.*?)<\/date>/";
      }
      else {
         $errorDescription = $errorDescription . "\n<p>Estructura XML no soportada.\n</p>";
         $errorCode = "69a";
         $errorCounter++;
         $arrayData[0]['error'] = $errorCode;
      }
     						  
      // Antes de nada tendremos que ver si esta definida la variable global 
      // '$isCA', que nos indica si estamos en la CA o no. En caso de que este
      // definida, parsearemos el fichero y todas sus solicitudes utilizando
      // la misma clave privada. Si esta definida, estamos en una RA y podemos 
      // firmar todas las trazas y solicitudes con la misma clave. Si no esta 
      // definida, estamos en la CA y tendremos que firmar cada solicitud con 
      // su clave privada correspondiente.
      if ( isset($isCA) && ($isCA == true) ) { 
         // Si no esta definida la variable global que contiene la clave
         // privada de la RA '$raPrivKey', necesitamos obtenerla del fichero
         // de claves (este caso solo debe cumplirse en la CA) o del propio
         // fichero de configuracion de la RA (para algunas operaciones en la RA).
         // Para el caso de private no hace falta ya que la clave privada la coge del propio XML
         if ( !isset($raPrivKey) && $xmlType != '"private"') {
            // Obtenemos los numeros copa del XML
      	    $r = preg_match($regex['copa_id'], $xmlContent, $xmlInfo['copa_id']);
	    // y nos quedamos con el numero de ra ('ai')
	    list ($raCopa, $k) = split ("b", $xmlInfo['copa_id'][1]);
	    $raPrivKey = getRaPrivKey($raCopa);
	    if ( !$raPrivKey ) {
	       $errorDescription = $errorDescription . "\n<p>No ha sido posible obtener la clave privada de la RA. Asegurese de que existe una clave valida para la RA. \n</p>";
	       $errorCode = "69";
	       $errorCounter++;
	    }
         }
         $privKey = $raPrivKey;
      }

      // Si no esta definida, estamos en una RA y tendremos que parsear el 
      // fichero con la clave de la CA y cada solicitud con su clave privada 
      // correspondiente
      else
         $privKey = $caPrivKey;

      if ( $errorCounter == 0 ) {       
         // Nos quedamos con todas las solicitudes del tipo 'requestsType' (lo que 
         // va entre <csrs> y </csrs> en las CSRs o entre <crt2ca> y </crt2ca> en 
         // los certificados de vuelta a la RA). El caso de las CRRs tendra un 
         // tratamiento diferente ya que no contiene este tipo de etiquetas (solo
         // viene una solicitud por fichero). Los XML que exportan la clave 
         // privada de la RA tampoco tienen estas etiquetas ni 'total_sig'
         if ( $xmlType != '"crr"' && $xmlType != '"private"' ) {
            preg_match($regex['requests_type'], $xmlContent, $xmlInfo['allRequests']);
    
            // Obtenemos la firma del fichero
            preg_match($regex['total_sig'], $xmlContent, $xmlInfo['total_sig']);
            $arrayData[0]['total_sig'] = $xmlInfo['total_sig'][1];
            // Comprobamos que los xmlContent no han sido modificados firmando con
            // la clave secreta de la RA. Tenemos que anyadirle un salto de linea
            // al bloque de las solicitudes
            $sha1_file_sig = sha1($xmlInfo['allRequests'][1] . "\n" . $privKey);
         }
         // En el caso de las CRRs y private no tenemos "total_sig", por lo que
         // inicializamos $xmlInfo['total_sig'] y '$sha1_file_sig' a false
         else {
	    $sha1_file_sig = false;     
            $xmlInfo['total_sig'][1] = $sha1_file_sig;
         }	 

         if ($xmlInfo['total_sig'][1] == $sha1_file_sig)
         {
            // Vamos a analizar cada solicitud
            $csrsNumber = preg_match_all($regex["request_type"], $xmlContent, $xmlInfo['requests']);
            for ($i = 0; $i < $csrsNumber; $i++) {
	       // Obtenemos el tipo de solicitud y la propia solicitud
   	       $request_type = $xmlInfo['requests'][1][$i];
               $currentRequest = $xmlInfo['requests'][2][$i];
	  
 	       // La informacion de la primera solicitud empezara en la posicion
	       // 1 del array
	       $index = $i+1; 
	    
   	       // Para el caso de private, solo hay que guardar el numero copa de
	       // la RA, su clave privada y la fecha de validez de la misma. No 
	       // tiene trazas a las que calcularle la firma
	       // PRIVATE
               if ( $xmlType == '"private"' ) {
                  $r = preg_match($regex['copa_id'], $currentRequest, $xmlInfo['copa_id']);
	          $r = preg_match($regex['date'], $currentRequest, $xmlInfo['date']);
                  $r = preg_match($regex['private_key'], $currentRequest, $xmlInfo['private_key']);
	          $r = preg_match($regex['sig'], $currentRequest, $xmlInfo['sig']);
                  $arrayData[$index]['copa_id'] = $xmlInfo['copa_id'][1];
   	          $arrayData[$index]['date'] = $xmlInfo['date'][1];
                  $arrayData[$index]['private_key'] = $xmlInfo['private_key'][1];
                  $arrayData[$index]['sig'] = $xmlInfo['sig'][1];
	      
	          // Componemos una cadena con la informacion de la solicitud
                  // para verificar si su suma de control sha1 es correcta
                  $cadena = "<copa_id>".$xmlInfo['copa_id'][1]."</copa_id>\n<date>".$xmlInfo['date'][1]."</date>\n<private_key>".$xmlInfo['private_key'][1]."</private_key>\n";
	          // Obtenemos la suma sha1 de la cadena + claveRA + pkirisCopaID
                  $sha1_request_sig = sha1($cadena.$xmlInfo['private_key'][1].$xmlInfo['copa_id'][1]);
	          if ( $sha1_request_sig != $xmlInfo['sig'][1] ) {
	             $errorDescription = $errorDescription . "\n<p>Se ha manipulado el fichero desde su env&iacute;o.</p>\n";
		     $errorCode = "69a";
		     $errorCounter++;
		     $arrayData[0]['error'] = $errorCode;
                  }									
               }
               else {														    
  	          // Sacamos la informacion del fichero XML. Datos comunes a
	          // los diferentes tipos de XML
	          $r = preg_match($regex['header'], $currentRequest, $xmlInfo['header']);
	          $r = preg_match($regex['data'], $currentRequest, $xmlInfo['data']);
	          $r = preg_match($regex['sig'], $currentRequest, $xmlInfo['sig']);
   	          $r = preg_match($regex['id'], $xmlInfo['header'][1], $xmlInfo['id']);
                  $r = preg_match($regex['copa_id'], $xmlInfo['header'][1], $xmlInfo['copa_id']); 
	          $r = preg_match($regex['dn'], $xmlInfo['header'][1], $xmlInfo['dn']);
	          $r = preg_match($regex['traces'], $xmlInfo['header'][1], $xmlInfo['traces']);
                  $tracesNumber = preg_match_all($regex['traceurn'], $xmlInfo['traces'][1], $xmlInfo['traceurn']);
            
	          // Y la anyadimos al array de retorno (menos data y sig que se 
	          // anyadiran al final). Dejamos la posicion 0 del array para datos 
	          // comunes a las solicitudes. 
	          for ($j = 0; $j < $tracesNumber; $j++)
                     $arrayData[$index]['traces'][$j] = $xmlInfo['traceurn'][1][$j]; 

                  $arrayData[$index]['id'] = $xmlInfo['id'][1];
                  $arrayData[$index]['copa_id'] = $xmlInfo['copa_id'][1];
	          $arrayData[$index]['dn'] = $xmlInfo['dn'][1];
	          $arrayData[$index]['requesttype'] = $request_type;
	    
	          // Dependiendo si es un tipo u otro de estructura XML, 
	          // obtendremos una informacion adicional direfente
	    
	          // CSRs 
	          if ( $xmlType == '"csr"' ) { 
      	             $r = preg_match($regex['nav_type'], $xmlInfo['header'][1], $xmlInfo['nav_type']);
   	             $r = preg_match($regex['ee_type'], $xmlInfo['header'][1], $xmlInfo['ee_type']);
   	             $r = preg_match($regex['mail'], $xmlInfo['header'][1], $xmlInfo['mail']);
	             $r = preg_match($regex['show_mail'], $xmlInfo['header'][1], $xmlInfo['show_mail']);
 	             $r = preg_match($regex['subject_dn'], $xmlInfo['header'][1], $xmlInfo['subject_dn']);
	    
	             // Completamos arrayData con la informacion que acabamos de
                     // obtener del XML
                     $arrayData[$index]['nav_type'] = $xmlInfo['nav_type'][1];
      	             $arrayData[$index]['ee_type'] = $xmlInfo['ee_type'][1];
	             $arrayData[$index]['mail'] = $xmlInfo['mail'][1];
                     $arrayData[$index]['show_mail'] = $xmlInfo['show_mail'][1];
                     $arrayData[$index]['subject_dn'] = $xmlInfo['subject_dn'][1];
                  }

	          // CRRs
	          else if ( $xmlType == '"crr"' ) {
                     $r = preg_match($regex['serial'], $xmlInfo['header'][1], $xmlInfo['serial']);
                     $r = preg_match($regex['revoked_by'], $xmlInfo['header'][1], $xmlInfo['revoked_by']);
   	             $r = preg_match($regex['reason'], $xmlInfo['header'][1], $xmlInfo['reason']);
	             $r = preg_match($regex['invalidity_date'], $xmlInfo['header'][1], $xmlInfo['invalidity_date']);

	             // Completamos arrayData con la informacion que acabamos de
                     // obtener del XML
                     $arrayData[$index]['serial'] = $xmlInfo['serial'][1];
                     $arrayData[$index]['revoked_by'] = $xmlInfo['revoked_by'][1];
	             $arrayData[$index]['reason'] = $xmlInfo['reason'][1];
	             $arrayData[$index]['invalidity_date'] = $xmlInfo['invalidity_date'][1];
	          }

	          // CRTs
	          else if ( $xmlType == '"crt"' ) {
	             $r = preg_match($regex['status'], $xmlInfo['header'][1], $xmlInfo['status']);
	             $r = preg_match($regex['date'], $xmlInfo['header'][1], $xmlInfo['date']);
	       
	             if ( $request_type == "crt" ) {
  	                $r = preg_match($regex['data'], $currentRequest, $xmlInfo['data']);
	                $r = preg_match($regex['expiration_date'], $xmlInfo['header'][1], $xmlInfo['expiration_date']);
		        $arrayData[$index]['expiration_date'] = $xmlInfo['expiration_date'][1];
	             }	       
	             // Completamos arrayData con la informacion que acabamos de
	             // obtener del XML
	             $arrayData[$index]['status'] = $xmlInfo['status'][1];
	             $arrayData[$index]['date'] = $xmlInfo['date'][1];
	          }   	    
	   
	          // Le anyadimos al array la firma de la solicitud
	          $arrayData[$index]['sig'] = $xmlInfo['sig'][1];
	   
	          // Componemos una cadena con la informacion de la solicitud
                  // para verificar si su suma de control sha1 es correcta
                  $cadena = "<header>".$xmlInfo['header'][1]."</header>\n";
	    
	          // Le anyadimos al array el contenido del tag 'data' (en caso de
                  // que no sea ni un certificado revocado ni uno rechazado). Tambien
	          // hay que añadirselo a la cadena
	          if ( $request_type != "rvk" && $request_type != "rfd" && $request_type != "private") {
	             $arrayData[$index]['data'] = $xmlInfo['data'][1];	       
                     $cadena = $cadena . "<data>".$xmlInfo['data'][1]."</data>\n";
	          }

                  // Si estamos parseando el fichero desde alguna RA, cada
                  // solicitud se habra firmado con la clave de su RA 
                  // correspondiente, por lo que tenemos que obtenerla y 
                  // comprobar que son correctas las firmas de todas ellas 
                  if ( !isset($isCA) ) {
                     // Nos quedamos con el numero de ra ('ai')
                     list ($raCopa, $k) = split ("b", $xmlInfo['copa_id'][1]);
                     $privKey = getRaPrivKey($raCopa);
                     if ( !$privKey ) {
                        $errorDescription = $errorDescription . "\n<p>No ha sido posible obtener la clave privada de la RA. Asegurese de que existe una clave valida para la RA. \n</p>";
                        $errorCode = "69";
                        $errorCounter++;
                     }
                  }
                  // Obtenemos la suma sha1 de la cadena + claveRA + pkirisCopaID
                  $sha1_request_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
	    
                  if ( $xmlInfo['sig'][1] == $sha1_request_sig ) { 
  	             // Tenemos que comprobar las firmas de todas trazas		 		 
	             $found = false;
                     while ( (list (,$value) = each($arrayData[$index]['traces'])) && !$found) {
                        // Parseamos la traza por el prefijo $pkirisTracePrefix
                        list($k, $tmp) = split($pkirisTracePrefix, $value);
                        // y metemos en un array el resto de componentes de la traza
		        $tr = split(":", $tmp);
      		        // Le quitamos el primer elemento porque no contiene nada
                        array_shift ($tr);
		  
		        // En traceIndices['sha1'] se encuentra el indice 
		        // correspondiente al campo que contiene la firma de la 
		        // traza ($0, $1 ... $4)
		        $sigIndex = $traceIndices['sha1'];
                        $traceSig = $tr[$sigIndex];
		  
                        // Componemos la cadena a verificar. Usaremos todos los 
                        // componentes de la traza menos la firma sha1
	      	        $g = 0;
		        while( $g < count($tr) ) {
		           // Si no es la firma, insertamos el elemento en el array
		           if ( $g != $sigIndex )
		              $trAux[$g] = $tr[$g];
		           // Si es el componente con la firma y no es el ultimo 
		           // elemento, insertamos el siguiente en el array
		           else if ( $g != count($tr) -1 ) {  
		              $trAux[$g] = $tr[$g+1];
			      $g++;
		           }			
		           $g++;
		        }
		  
                        $cadena =  "$pkirisTracePrefix:$trAux[0]:$trAux[1]:$trAux[2]:$trAux[3]";
		        // Obtenemos el sha1 de la cadena		 
		        $sha1_trace_sig = sha1($cadena . $privKey . $xmlInfo['copa_id'][1]);
                        if ($traceSig != $sha1_trace_sig) {
                           $found = true;
                           $errorDescription = $errorDescription . "\nLas trazas han sido manipuladas.";
	                   $errorCode = "69";
	                   $errorCounter++;
                           $arrayData[0]['error'] = $errorCode;
                        }
                     } //endwhile		    		 
                  }
	          else {
	             $errorDescription = $errorDescription . "\n<p>Se ha manipulado al menos una solicitud desde su env&iacute;o.</p>\n";
                     $errorCode = "69a";
                     $errorCounter++;
                     $arrayData[0]['error'] = $errorCode;						  
                  }
	       } 
            } //endfor  
         }
         else {
            $errorDescription = $errorDescription . "\n<p>El fichero ha sido manipulado desde su env&iacute;o.</p>\n";
            $errorCode = "69b";
            $errorCounter++;
            $arrayData[0]['error'] = $errorCode;
         }
      }
   }
   if ($errorCounter == 0)
      $retValue = $arrayData;
   else {
      echo "Error parseando el fichero XML." . $errorDescription . $error;
      $retValue = false;
   }
   
   return $retValue;
}

#
# function createXML: esta funcion crea un fichero con el codigo XML de todas 
# las solicitudes, el cual sirve para transmitir informacion entre la RA y la 
# CA. Recibe un array los codigos copa de las solicitudes o los certificados 
# que van a ser exportados, y devuelve una cadena con el codigo XML si no ha 
# habido ningun error o 'false' en el caso de que si los haya habido. Esta 
# funcion crea un fichero con el codigo XML de todas las solicitudes, el cual 
# sirve para transmitir informacion entre la RA y la CA.
#
function createXML ($copasArray) {
   global $rdn1;
   global $base;
   global $raPrivKey;
   global $isCA;
   global $binOpenssl;
   global $crtData; 
  
   $xmlString = "";
   $retValue = false;
   $errorCounter = 0; 
   $initializedXmlFileInfo = false;   
   
   // Tratamos todas las solicitudes con los numeros copa incluidos en el array
   // de entrada '$copasArray'. Si hay algun error paramos
   while ( (list(,$copa) = each ($copasArray)) && $errorCounter == 0 ) {
      $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))"; 
      $justthese = array ("dn","pkirisid","pkirisstatus","pkiristrace");
      $info = ldap_get_info($base,$filter,$justthese);
      
      if ( $info == false ) {
         $errorCode = 69;
	 $errorCounter ++;
	 $errorDescription = "No se ha podido obtener la informaci&oacute;n del ldap";
      }

      else {

	 $status = $info[0]['pkirisstatus'][0];
         // La exporatcion de puede realizar desde nueve estados diferentes. 
	 // Dependiendo si es uno u otro las variables tomaran unos valores u 
	 // otros:
         if ( $status == "approved" ) {
	    // Tendremos que ver si es una 'csr' o una 'rnr'
            $requestType = getRequestTypeFromTraces ($copa);	
	    
	    // En '$exportStatus' guardamos el estado al que tendremos que
	    // cambiar la solicitud cuando se haya generado el XML, es decir,
	    // 'ra2ca' (exportada de la RA a la CA) o 'ca2ra (al contrario)
	    $exportStatus = "ra2ca";

	    // En '$traceStatus' vamos a guardar el estado desde el cual vamos
	    // a incluir en el XML las trazas del ldap al que vayamos a 
	    // exportar las solicitudes. Esto se hace para evitar repetir las 
	    // trazas al importar el XML
	    if ( $requestType == "csr" )
	       $traceStatus = "new";
	    else
	       $traceStatus = "renew";
	       
            // En el array 'xmlFileInfo' guardaremos informacion necesaria para
            // generar el fichero XML en la funcion 'createXMLFile' 	    
	    if (!$initializedXmlFileInfo) {
	       $initializedXmlFileInfo = true;
  	       $xmlFileInfo['xmlType'] = "csr";
	       $xmlFileInfo['requestsContainer'] = "csrs";
	       // Obtenemos el numero de RA (entre la 'a' y la 'b' de $copa).
	       // Todas las solicitudes pertenecen a la misma RA
	       list($kk,$tmp)=split("a",$copa);
	       list($num,$kk)=split("b",$tmp);
	       $xmlFileInfo['reqRaNum'] = $num;
	       $initializedXmlFileInfo = true; 
	    }
	 }	
	 else if ( $status == "issued" ) { 
	    $requestType = "crt";
            $exportStatus = "ca2ra";
	   
	    // Dependiendo si es una solicitud o una renovacion de certificado,
	    // anyadiremos las trazas desde la que tenga el estado 
	    // 'csr-pending' o 'rnr-pending' (las anyadidas en la CA)
            $originalRequestType = getRequestTypeFromTraces ($copa);	    
	    $traceStatus = "$originalRequestType-pending";
	    
	    if (!$initializedXmlFileInfo) {
               $xmlFileInfo['xmlType'] = "crt";
   	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	    
	 else if ( strstr($status,"revoked-") ) {
	    $requestType = "rvk";
            $exportStatus = "ca2ra";

            // El tratamiento para cuando la CA revoca una solicitud es un
            // poco especial ya que no sabemos que tipo de solicitud es. Lo
            // vremos mas adelante	    
            if ( $status == "revoked-ca" )
               $traceStatus = $status;
	    
	    // Para los estados 'revoked-ra' y 'revoked-usr', anyadiremos las 
	    // trazas desde la que tenga el estado 'crr-pending'
            else 
	       $traceStatus = "crr-pending";

	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crt";
	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	 
	 else if ( strstr($status,"-refused") ) {
	    $requestType = "rfd";
	    $exportStatus = "ca2ra";

	    // Dependiendo si se ha rechazado una 'csr', una 'rnr' o una 'crr',
	    // anyadiremos las trazas desde 'csr/rnr/crr-pending'
            list($originalRequestType, $k) = split ("-refused", $status);
            $traceStatus = "$originalRequestType-pending";

	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crt";
	       $xmlFileInfo['requestsContainer'] = "crt2ra";
	       $initializedXmlFileInfo = true;
	    }
	 }	    
	 else if ( $status == "revoke" ) {
	    $requestType = "crr";
	    $exportStatus = "ra2ca";
	    $traceStatus = "revoke";
            
	    if (!$initializedXmlFileInfo) {
  	       $xmlFileInfo['xmlType'] = "crr";
	       $xmlFileInfo['requestsContainer'] = "";
	       $initializedXmlFileInfo = true;
	    }
	 }	   
	 else if ( $status == "ra2ca" || $status == "ca2ra" ) {
	     $errorCode = 69;
             $errorCounter ++;
             $errorDescription = "\n<p>La solicitud o certificado ya ha sido exportada/o anteriormente.</p>\n";
	 }
	 else {
            $errorCode = 69;
            $errorCounter ++;
            $errorDescription = "\n<p>Estado no v&aacute;lido de la solicitud o certificado.</p>\n";
	 }
	 if ( $errorCounter == 0) {
   	    // Guardamos en variables la informacion obtenida del ldap
            $dn = $info[0]['dn']; 
            $pkid = $info[0]['pkirisid'][0];

            // Primero escribimos los tags XML comunes a todos los tipos de 
	    // solicitudes
            $xmlString = $xmlString . "<$requestType>\n";	 
      	    // En $xmlStringSig guardamos la parte del XML de la 
	    // solicitud/certificado a la que le aplicaremos la suma de control
            $xmlStringSig = "<header>\n";   
            $xmlStringSig = $xmlStringSig . "<id>$pkid</id>\n";
            $xmlStringSig = $xmlStringSig . "<copa_id>$copa</copa_id>\n";
            $xmlStringSig = $xmlStringSig . "<dn>$dn</dn>\n";
            $xmlStringSig = $xmlStringSig . "<traces>\n";
           
	    // Obtenemos solo las trazas anyadidas desde el estado $traceStatus

	    // El caso de 'revoked-ca' tiene un tratamiento especial, ya que no
	    // podemos saber el tipo de la solicitud (puede ser una csr, una
	    // rnr o una crr). Por lo tanto, tendremos que probar para las 3. 
	    // Nos quedaremos con las trazas del estado que no devuelva 'false'
            if ( $traceStatus == "revoked-ca" ) {
	       $arrayTraces = getTracesFromStatus ($copa, "csr-pending");
	       if ( $arrayTraces == false ) {
	          $arrayTraces = getTracesFromStatus ($copa, "rnr-pending");
		  if ( $arrayTraces == false )
                     $arrayTraces = getTracesFromStatus ($copa, "crr-pending");
	       }
	    }
	    // Para el resto de casos, obtenemos las trazas anyadidas desde el
	    // estado $traceStatus
	    else
	       $arrayTraces = getTracesFromStatus ($copa, $traceStatus);
	       
	    if ( $arrayTraces == false ) {
	       $errorDescription = $errorDescription . "\nLa solicitud con numero copa $copa no contiene ninguna traza con estado $traceStatus.";
	       $errorCode = 69;
	       $errorCounter++;
	    }	    
	    $tracesNum = count ($arrayTraces);
            for ($k = 0; $k < $tracesNum; $k++) {
               $trace = $arrayTraces[$k];
	       $xmlStringSig = $xmlStringSig . "<trace>$trace</trace>\n";
	    }	 
            $xmlStringSig = $xmlStringSig . "</traces>\n";
  
            // Cada tipo de solicitud tendra unos tags particulares
   
            // CSRs
            if ( $requestType == "csr" || $requestType == "rnr" ) {
               // Obtenemos los valores de las etiquetas del ldap
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkiriscerttype","mail","pkirisshowmail","pkirissubjectdn","pkiriscsr");
               $info = ldap_get_info($base,$filter,$justthese);	 

   	       if ( $info == false ) {
	          $errorCode = 69;
   	          $errorCounter ++;
	          $errorDescription = "Error obteniendo informaci&oacute;n del ldap";
	       }	    
	       else {
                  $ee_type = $info[0]['pkiriscerttype'][0];
                  $mail = $info[0]['mail'][0];
                  $showmail = $info[0]['pkirisshowmail'][0];
                  $subjectdn = $info[0]['pkirissubjectdn'][0];
   	          $data = $info[0]['pkiriscsr'][0] . "\n";
	   
  	          // Obtenemos el tipo de navegador desde el que se realizo la solicitud
	          $nav_type = getNavType($copa);
	 
                  // Escribimos las etiquetas con sus valores en la cadena
                  $xmlStringSig = $xmlStringSig . "<nav_type>$nav_type</nav_type>\n";
                  $xmlStringSig = $xmlStringSig . "<ee_type>$ee_type</ee_type>\n";
                  $xmlStringSig = $xmlStringSig . "<mail>$mail</mail>\n";
                  $xmlStringSig = $xmlStringSig . "<show_mail>$showmail</show_mail>\n";
                  $xmlStringSig = $xmlStringSig . "<subject_dn>$subjectdn</subject_dn>\n";  
      	       }
            }

            // CRTs y RVKs 
            else if ( $requestType == "crt" || $requestType == "rvk" || $requestType == "rfd" ) {
               // Obtenemos los valores de las etiquetas del ldap
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkirisdate","usercertificate","pkiriscertificateexpirationdate");
	       $info = ldap_get_info($base,$filter,$justthese);

  	       if ( $info == false ) {
	          $errorCode = 69;
	          $errorCounter ++;
	          $errorDescription = "Error obteniendo informaci&oacute;n del ldap";
	       }
  
	       else {   
                  $date = $info[0]['pkirisdate'][0];
                  $expirationdate = $info[0]['pkiriscertificateexpirationdate'][0];
     
		  // Si el XML va a contener un certificado, tenemos que
		  // obtenerlo
		  if ($requestType == "crt") {
		     // Tambien tenemos que obtener el certificado del usuario
		     $userCert = ldap_get_cert($base,$filter);
                     $derFile = $crtData . $copa.".x509ee";
		       // Verificamos si existe el fichero y si no lo creamos y volcamos la info del certificado en el
		     if (!file_exists($derFile)) {
		        $der = fopen($derFile, "w");
			fputs($der, $userCert[0]);
			fclose($der);
		     }
                     // Inicializamos las variables
                     $txtCert = array();
                     $data = "";
                     
                     // Pasamos el certificado a formato texto
		     $r = exec($binOpenssl . " x509 -text -inform DER < " .$derFile, $txtCert);
                     for($i = 0; $i < count($txtCert); $i++) 
	                $data = $data . $txtCert[$i] . "\n";                     
                  }   		     
                  // Escribimos las etiquetas con sus valores en la cadena      
                  $xmlStringSig = $xmlStringSig . "<status>$status</status>\n";
                  $xmlStringSig = $xmlStringSig . "<date>$date</date>\n";
                  $xmlStringSig = $xmlStringSig . "<expiration_date>$expirationdate</expiration_date>\n";
	       }
            }
            // CRRs
            else {
               // Obtenemos los valores de las etiquetas del ldap
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkirisrevokedbycopaid","pkirisrevocationreason");
               $info = ldap_get_info($base,$filter,$justthese);

  	       if ( $info == false ) {
                  $errorCode = 69;
	          $errorCounter ++;
	          $errorDescription = "Error obteniendo informaci&oacute;n del ldap";
	       }
               else {
                  $revokedby = $info[0]['pkirisrevokedbycopaid'][0];
                  $reason = $info[0]['pkirisrevocationreason'][0];
                  $invaliditydate = date("YmdHis"); // En un futuro, esta variable debe tener otro valor
      
		  // Tambien tenemos que obtener el certificado del usuario y 
		  // su numero de serie                                   
		  $userCert = ldap_get_cert($base,$filter);
		  $derFile = $crtData . $copa.".x509ee";
                    // Verificamos si existe el fichero y si no lo creamos y 
		    // volcamos la info del certificado en el
                  if (!file_exists($derFile)) {
                     $der = fopen($derFile, "w");
		     fputs($der, $userCert[0]);
		     fclose($der);
		  }
                    // Pasamos el certificado a formato texto
		  $r = exec($binOpenssl . " x509 -text -inform DER < " .$derFile, $txtCert);
                  $data = "";		  
 
		  for( $i = 0; $i < count($txtCert); $i++ ) {
                     $data = $data . $txtCert[$i] . "\n";
	             list($tmp, $k) = split(":",trim($txtCert[$i]));
		     if( $tmp == "Serial Number" ){
		        list($k, $tmp) = split("\(",$txtCert[$i]);
		        list($serial, $k)=split("\)",$tmp);
		     }
		  }

		  // Escribimos las etiquetas con sus valores en la cadena
                  $xmlStringSig = $xmlStringSig . "<serial>$serial</serial>\n";
                  $xmlStringSig = $xmlStringSig . "<revoked_by>$revokedby</revoked_by>\n";
                  $xmlStringSig = $xmlStringSig . "<reason>$reason</reason>\n";
                  $xmlStringSig = $xmlStringSig . "<invalidity_date>$invaliditydate</invalidity_date>\n";

		  // Para generar el fichero XML le tenemos que pasar a la
		  // funcion 'createXMLFile' el numero copa y el de serie
		  $xmlFileInfo['copa'] = $copa;
		  $xmlFileInfo['serial'] = $serial;
	       }
            }

            $xmlStringSig = $xmlStringSig . "</header>\n";
            // Ni las revocaciones efectuadas ni las solicitudes rechazadas
	    // contendran el certificado ni la CSR (el tag data)
   	    if ( $requestType != "rvk" && $requestType != "rfd")	    
               $xmlStringSig = $xmlStringSig . "<data>\n$data</data>\n";

            // Antes de nada tendremos que ver si esta definida la variable 
            // global '$isCA' que indica si estamos o no en la CA. Si esta
            // definida (indica que estamos en la CA), tendemos que firmar 
            // cada solicitud con su clave privada correspondiente. Si no esta 
            // definida, estamos en una RA y podemos firmar todas las trazas y 
            // solicitudes con la misma clave 
            if ( isset($isCA) && ($isCA == true) ) {
               // Obtenemos el numero de ra ('ai')
               list ($raCopa, $k) = split ("b", $copa);
               $raPrivKey = getRaPrivKey($raCopa);
               if ( !$raPrivKey ) {
                  $errorDescription = $errorDescription . "\n<p>No ha sido posible obtener la clave privada de la RA. Asegurese de que existe una clave valida para la RA. \n</p>";
                  $errorCode = "69";
                  $errorCounter++;
               }
            }            
            $xmlString = $xmlString . $xmlStringSig . "<sig>".sha1($xmlStringSig.$raPrivKey.$copa)."</sig>\n" . "</$requestType>\n";	 
         }
      }
   }
   
   // Una vez que tenemos el codigo XML de todas las solicitudes, creamos el
   // fichero y volcamos la informacion en el
   if ( $errorCounter == 0 ) {
      $retValue = createXMLFile( $xmlString, $xmlFileInfo ); 
      if ( !$retValue ) {
         $errorCode = 69;
         $errorCounter ++;
      }         
      // Si se ha generado el fichero correctamente, cambiamos el estado de
      // las solicitudes
      else { 
         $r = setExportedStatus ( $copasArray , $exportStatus ); 
	 if ( !$r ) {
  	    $errorCode = 69;
	    $errorCounter ++;
	    $retValue = false;
	 }
      }
   }  
   else
      echo $errorDescription; 
   
   return $retValue;
}

#
# function createXmlFile: recibe una cadena con el codigo XML correspondiente
# a todas las solicitudes de certificado (CSRs/RNRs) o de revocacion (CRRs), 
# certificados (CRTs) o revocaciones (RVKs), le anyade una cabecera y un pie 
# con informacion sobre la version y el tipo del XML a la cadena de entrada, y
# por ultimo crea un fichero con ellas. Devuelve la cadena generada o false si 
# ha habido algun error. El fichero se usara para enviar informacion de la RA
# a la CA y viceversa.
#
function createXMLFile ( $xmlStringSigned, $xmlFileInfo ) {
   global $raPrivKey;
   global $caPrivKey;
   global $isCA;
   global $csrData;
   global $crrData;
   global $crt2raData; 
   
   $retValue = false;
   $errorCounter = 0;
   
   $xmlType = $xmlFileInfo['xmlType'];
   $requestsContainer = $xmlFileInfo['requestsContainer'];
    
   $xmlString = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n\n";
   $xmlString = $xmlString . "<pki type=\"$xmlType\" version=\"1.0\">\n";
   
   // $requestsContainer sera vacio cuando estemos creando un fichero con una 
   // CRR, ya que este tipo de XML no necesita ese tipo de tag. Tampoco tienen
   // la firma total del fichero
   if ( $requestsContainer != "") {   
      $xmlStringTotalSig = "<$requestsContainer>\n" . $xmlStringSigned . "</$requestsContainer>\n";
      // Firmamos $xmlStringTotalSig usando la clave privada de la RA (si
      // estamos exportando de una RA a la CA) o con la de la CA (si se 
      // exporta de la CA a la RA). Sabremos que estamos en una CA si esta
      // definida la variable global '$isCA'
      if ( isset($isCA) && ($isCA == true) )
         $privKey = $caPrivKey;
      else
         $privKey = $raPrivKey;

      $xmlString = $xmlString . $xmlStringTotalSig . "<total_sig>".sha1($xmlStringTotalSig . $privKey)."</total_sig>\n";
   }
   else 
      $xmlString = $xmlString . $xmlStringSigned;
     
   // Por ultimo, le anyadimos el tag de cierre de 'pki'
   $xmlString = $xmlString . "</pki>\n";

   // Dependiendo del tipo de XML, el fichero tendra un nombre u otro   
   if ( $requestsContainer == "csrs" ) {
      $reqRaNum = $xmlFileInfo['reqRaNum']; 
      $xmlFile = $csrData . "csr_r".$reqRaNum."d".date('Ymd')."t".date('His').".xml";
   }
   else if ( $requestsContainer == "crt2ra" ) 
      $xmlFile = $crt2raData . "ca2ra_d".date('Ymd')."t".date('His').".xml";
   else {
      $copa = $xmlFileInfo['copa'];
      $serial = $xmlFileInfo['serial']; 
      $xmlFile = $crrData . "crr_".$copa."-".$serial.".xml";
   }
   
   // Abrimos el fichero para escribir 
   $fd = fopen ($xmlFile, "w");

   if ($fd == false) {
      $errorDescription = $errorDescription . "\nNo es posible abrir el fichero $xmlFileName.";
      $errorCode = 69;
      $errorCounter++;
   }
   else {
      // Si no hay errores, escribimos la cadena XML en el fichero
      $r = fwrite ($fd, $xmlString);
      if ($r == false) {
         $errorDescription = $errorDescription . "\nNo es posible escribir en el fichero $xmlFile.";
         $errorCode = 69;
         $errorCounter++;
      }      

      $r = fclose ($fd);      
      if ($r == false) {
         $errorDescription = $errorDescription . "\nNo es posible cerrar el fichero $xmlFile.";
	 $errorCode = 69;
	 $errorCounter++;
      }
   }
   if ( $errorCounter == 0 )
      $retValue = $xmlString;
   else
      echo $errorDescription;
      
   return $retValue;
}

#
# function setExportedStatus: recibe un array con el codigo copa de todas las
# solicitudes pendientes de ser exportadas y les cambia el estado a 'ra2ca' o
# 'ca2ra', dependiendo del origen y el destino de la solicitud. Ademas, se le
# cambia la fecha y se genera e inserta el el ldap una traza con el nuevo 
# estado.
#
function setExportedStatus ( $copasArray , $status) {
   global $rdn1;
   global $base;
   
   $currentDate = date("YmdHis");   
   
   while ( list(,$copa) = each($copasArray) ) {
      $lastStatus = getStatus($copa);
      // Esta comprobacion se hace para evitar que se escriba dos veces la
      // misma traza al recargar el navegador
      if ($lastStatus != $status) {
         // Traza con el nuevo estado
	 $traceVals["status"] = $status;
	 $traceVals["copa"] = $copa;
	 $traceVals["currentDate"] = $currentDate;
	  
	 // Construimos la traza con los valores de $traceVals
	 $newTrace = getTrace($traceVals);

	 $dn = $rdn1."=".$copa.",".$base;
	 $updateFields["pkirisstatus"] = $status;
	 $updateFields["pkirisdate"] = $currentDate;
	 $urn["pkiristrace"] = $newTrace;

	 // Modificamos el campo pkiDate y pkiStatus del ldap
	 $r = ldap_mod_info ($dn, $updateFields);
  
	 if (!$r) {
	    $errorNumber = 69;
	    $errorCounter ++;
	    $errorDescription = "\n<p>No se ha podido modificar la informaci&oacute del ldap.</p>\n";
	 }
	 else {
	    // Modificamos el campo pkiTrace para agregar la nueva traza firmada
	    $r = ldap_mod_add_info ($dn, $urn);
            if (!$r) {
               $errorNumber = 69;
               $errorCounter ++; 
	       $errorDescription = "\n<p>No se ha podido modificar la informaci&oacute del ldap.</p>\n";					
	    }
         }
      }
      else{
         $errorNumber = 69;
	 $errorDescription = "\n<p>Al menos una de las CSR tiene un estado no v&aacute;lido. No se ha completado la exportaci&oacute;n de todas las solicitudes.</p>\n";
      }
   }//while

   if ( $errorCounter == 0 )
      $retValue = true;
   else {
      echo $errorDescription;
      $retValue = false;
   }
   
   return $retValue;   
}

#
# function revoke: recibe el codigo copa de una solicitud de revocacion y 
# revoca el certificado correspondiente. Tambien recibe el estado al que 
# pasara el certificado (revoked-usr, revoked-ra o revoked-ca), es decir, 
# si lo ha revocado el usuario, el administrador de la RA o el de la CA. 
# En el ultimo caso, la revocacion debe llevarse a cabo lo antes posible, 
# sin tener en cuenta el estado del certificado. El ultimo paramentro de
# entrada, la 'passPhrase', es la contrasenya de la CA, y es necesaria para 
# efectuar cualquier operacion de la CA. Devuelve 'true' si no ha habido 
# ningun error; 'false' en caso contrario. 
#
function revoke ( $copa, $status, $passPhrase ) {
   global $crtData;
   global $rdn1;
   global $base; 
   global $binOpenssl;
   global $opensslConf; 

   $dn = "$rdn1=$copa,$base";   
   $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
   $justthese = array ("pkirisrevocationreason");
   $info = ldap_get_info($dn,$filter,$justthese);

   $revReason = $info[0]["pkirisrevocationreason"][0];
   $retValue = false;
   // Comprobamos si el estado anterior al que queremos cambiar
   // es valido, es decir, si cumple el diagrama de estados. Con
   // esto evitamos que se escriba dos veces el mismo estado al
   // refrescar la pagina en el navegador, entre otras cosas
   $lastStatus = getStatus($copa);
   
   if ( ($lastStatus == "crr-deferred" || $lastStatus == "crr-pending" || $status = "revoked-ca") && ($lastStatus != $status) ) {
      // Nos traemos el certificado el ldap
      $justthese = array("usercertificate");
      $userCert = ldap_get_cert($dn,$filter,$justthese);
      // Y si no existe el fichero '.der' correspondiente al
      // mismo lo creamos
      $derFile = "$crtData$copa.der";
      if ( !file_exists($derFile) ) {
         $der = fopen ($derFile, "w");
         fputs($der, $userCert[0]);
         fclose ($der);
      }
      // Mediante el siguiente comando de openssl, pasamos el
      // certificado del formato '.der' a '.pem'
      $opensslCommand = "$binOpenssl x509 -in $derFile -inform DER -out $crtData$copa.pem -outform PEM";
      // Con este comando revocamos el certificado '.pem'
      $opensslCommand2 = "pkirisID=NULL pkirisEMAIL=NULL $binOpenssl ca -revoke $crtData$copa.pem -key $passPhrase -config $opensslConf -crl_reason $revReason 2>&1";
      $execReturn = system($opensslCommand,$retval);
      $execReturn2 = system($opensslCommand2,$retval);
      if ( $execReturn2 != "Data Base Updated" ) {
         $errorDescription = $errorDescription . "\nOpenssl: $execReturn2";
         $errorCode = 69;
         $errorCounter++;
      }       
   }
   else {
      $errorDescription = $errorDescription . "\n<p>La solicitud $copa ya ha sido tratada anteriormente.</p>\n";
      $errorCode = 69;
      $errorCounter++;
   }

   if ( $errorCounter == 0 )
      $retValue = true;
   else
      echo $errorDescription;

   return $retValue;
}

# 
# function sign: recibe el codigo copa de una solicitud de certificado y
# si todo es correcto, emite el certificado correspodiente. Tambien recibe el 
# estado al que pasara el certificado. El ultimo paramentro de entrada, la 
# 'passPhrase', es la contrasenya de la CA, y es necesaria para efectuar 
# cualquier operacion de la CA. Genera el certificado en tres formatos: en der, 
# en pem y en texto. Devuelve 'true' si no ha habido ningun error; 'false' en 
# caso contrario.
#
function sign ( $copa, $status, $passPhrase ) {
   global $crtData;
   global $rdn1;
   global $base;
   global $binOpenssl;
   global $opensslConf;

   $retValue = false;
   $subjString = '';

   // Nos traemos de ldap la informacion necesaria para
   // emitir el certificado
   $dn = "$rdn1=$copa,$base";
   $filter = ("pkirisCopaID=$copa");
   $justthese = array ("pkiriscsr", "pkiriscerttype", "pkirissubjectdn", "pkirisshowmail", "mail");
   $info = ldap_get_info($dn,$filter,$justthese);
   if (!$info) {
      $errorDescription = $errorDescription . "\n<p>No se ha podido modificar la informaci&oacute;n del ldap.</p>\n";
      $errorCode = 69;
      $errorCounter++;
   }
   else {
      $requestId = $info[0]['pkirisid'][0];
      $pkirisCSR = $info[0]['pkiriscsr'][0];
      $certType = $info[0]['pkiriscerttype'][0];
      $subjectDN = $info[0]['pkirissubjectdn'][0];
      $showMail = $info[0]['pkirisshowmail'][0];
      $mail = $info[0]['mail'][0];

      if ( strncmp("SPKAC", $pkirisCSR, 5) == 0 ) {
         $csrType = "SPKAC";

         // Para que openssl funcione correctamente, tenemos que
         // pasarle el SubjectDN de la forma: /DC=a/DC=b/O=c/CN=d
         $arraySubjectDN = split (",",$subjectDN);
         for ($i=0; $i<count($arraySubjectDN); $i++){
            list($leftValue, $rightValue) = split ("=", $arraySubjectDN[$i]);
            $leftValue = strToUpper ($leftValue);
            // Si el subjectDN es de un certificado de servicio, hay
            // que añadirle el caracter de escape"\" antes de l
            // barra "/" para evitar conflictos con openssl
            list($rightValue, $subValue) = split ("/", $rightValue);
            if ($subValue != "")
               $rightValue = $rightValue . '\\/' . $subValue;
               $subjString = "$subjString/$leftValue=$rightValue";
         }
      }
      else
         $csrType = "IE";

      // Tenemos que crear un fichero con la clave privada
      $csrFileName = "$crtData$copa.csr";
      $fd = fopen ($csrFileName, w);
      if ($fd == false) {
         $errorDescription = $errorDescription . "\n<p>No es posible abrir el fichero $csrFileName.</p>\n";
         $errorCode = 69;
         $errorCounter++;
      }
      else {
         $r = fwrite ($fd, $pkirisCSR);
         if ($r == false) {
            $errorDescription = $errorDescription . "\n<p>No es posible escribir en el fichero $csrFileName.</p>\n";
            $errorCode = 69;
            $errorCounter++;
         }
         else {
            // Comprobamos que estamos en un estado valido
            $lastStatus = getStatus($copa);
            if ( ($lastStatus == "csr-deferred" || $lastStatus == "rnr-deferred" || $lastStatus == "csr-pending" || $lastStatus == "rnr-pending") && ($lastStatus != $status) ) 
            {
               // Si el certificado es de tipo usuario y este lo permite,
               // firmaremos con su email
               if ( ($showMail == "TRUE") AND ($certType == "usr") )
                  $extensions = "usr_cert_sujectAltName_mail";
               else {
                  $extensions = "$certType"."_cert";
                  $mail = "NULL";
               }
                // Para firmar ejecutamos un comando de openssl con una
               // serie de argumentos. El comando sera diferente
               // dependiendo del tipo de CSR (spkac o msie)
               if ( $csrType == "SPKAC" )
                  $opensslCommand = "pkirisID=$copa pkirisEMAIL=$mail $binOpenssl ca -spkac $csrFileName -key $passPhrase -config $opensslConf -subj \"$subjString\" -extensions $extensions -out $crtData$copa.der 2>&1";
               else // IE
                  $opensslCommand = "pkirisID=$copa pkirisEMAIL=$mail $binOpenssl ca -in $csrFileName -key $passPhrase -config $opensslConf -extensions $extensions -out $crtData$copa.txt -batch 2>&1";

               // Ejecutamos el comando
               $execReturn = system($opensslCommand,$retval);
               // Si falla la ejecucion del mismo, apuntamos el error
               // y no seguimos el proceso de firma
               if ( $execReturn != "Data Base Updated" ) {
                  $errorDescription = $errorDescription . "\nOpenssl: $execReturn";
                  $errorCode = 69;
                  $errorCounter++;
               }
               else {
                  // Para las solicitudes de SPKAC se genera el
                  // certificado en formato '.der' y lo necesitamos
                  // en '.pem' para obtener la fecha de expiracion
                  if ( $csrType == "SPKAC" ) {
                     $opensslCommand2 = "$binOpenssl x509 -in $crtData$copa.der -inform DER -out $crtData$copa.pem -outform PEM";
                     $execReturn2 = system($opensslCommand2,$retval);
                  }
                  // En las de tipo IE, se genera el certificado en
                  // formato texto. Lo necesitamos en '.pem' y en
                  // '.der'
                  else {
                     $opensslCommand2 = "$binOpenssl x509 < $crtData$copa.txt > $crtData$copa.pem ";
                     $opensslCommand3 = "$binOpenssl x509 -in $crtData$copa.pem -inform PEM -out $crtData$copa.der -outform DER";
                     $execReturn2 = system($opensslCommand2,$retval);
                     $execReturn3 = system($opensslCommand3,$retval);
                  }
                  /* if ( $execReturn2 != "Data Base Updated" ) {
                     $errorDescription = $errorDescription . "\nOpenssl: $execReturn2";
                     $errorCode = 69;
                     $errorCounter++;
                  }*/
               }
            }
            else {
               $errorDescription = $errorDescription . "\n<p>La solicitud $copa ya ha sido tratada anteriormente.</p>\n";
               $errorCode = 69;
               $errorCounter++;
            }
         }
         fclose ($fd);
      }
   }

   if ( $errorCounter == 0 )
      $retValue = true;
   else
      echo $errorDescription;

   return $retValue;
}


#
# function exportRaPrivKey: this function exports the Ra private key which copa
# code is '$copa'
#
function exportRaPrivKey($copa, $date) {
      global $base;
      global $confDir;
      global $privateData;

      $retValue = false;

      // Obtenemos la clave privada de la RA
      $privKey = getRaPrivKey ($copa);
	 
      // Construimos el fichero XML con el numero copa y la clave privada
      if ( $privKey != false ) {
         $xmlString = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n\n";
         $xmlString = $xmlString . "<pki type=\"private\" version=\"1.0\">\n";
         $xmlString = $xmlString . "<private>\n";
         $xmlString = $xmlString . "<copa_id>$copa</copa_id>\n";
         $xmlString = $xmlString . "<date>$date</date>\n";
         $xmlString = $xmlString . "<private_key>$privKey</private_key>\n";
         // Calculamos la suma de control 'sha1'
         $cadena = "<copa_id>$copa</copa_id>\n" . "<date>$date</date>\n" . "<private_key>$privKey</private_key>\n"; 
	 $xmlString = $xmlString . "<sig>" . sha1($cadena.$privKey.$copa) . "</sig>\n";
	 $xmlString = $xmlString . "</private>\n";
	 $xmlString = $xmlString . "</pki>";
	 
         // Abrimos el fichero XML para escribir
         $xmlFile = $privateData . "private_d".date('Ymd')."t".date('His').".xml"; 
         $fd2 = fopen ($xmlFile, "w");
 
         if ( $fd2 == false ) 
	    echo "\nNo es posible abrir el fichero $xmlFile.";
         else {
            // Si no hay errores, escribimos la cadena XML en el fichero
            $r = fwrite ($fd2, $xmlString);
            if ($r == false)
               echo "\nNo es posible escribir en el fichero $xmlFile.";
            else
	       $retValue = $xmlString;

            fclose ($fd2);
         }
      }
   return $retValue;
}

#
# function getRaPrivKey(): devuelve la clave privada de la RA indicada por
# '$copa'. Buscara en el fichero de claves privadas aquella que tenga la fecha
# mas cercana a la actual pero menor que ella, o si no existe este fichero, 
# directamente en el fichero de configuracion de la propia RA.
#
function getRaPrivKey($copa) {
   global $privateConfDir;
   global $base;
   global $confDir;
   
   $retValue = false;
   // Si existe el fichero con todas las claves privadas de todas las RAs,
   // obtenemos la clave de la RA indicada por $copa
   if ( file_exists($privateConfDir . 'private.conf') ) {
      // Incluimos el fichero con todas las claves privadas de todas las RAs
      include $privateConfDir . 'private.conf';
      // Ordenamos el array de mayor a menor fecha y nos quedamos con la 
      // primera que sea menor que la fecha actual
      if ( count ( $raPrivKeyArray[$copa] ) > 0 ) {
         krsort( $raPrivKeyArray[$copa] );
         $currentDate = date ("YmdHis");
         $found = false;
         while ( (list($date, $key) = each ($raPrivKeyArray[$copa])) && !$found) {
            if ( $date < $currentDate ) {
	       $retValue = $key;
	       $found = true;
	    }
         }
      }
   }   
   else {
      // Obtenemos el ldap la url de la RA para poder buscar su fichero
      // de configuracion
      $filter = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$copa))";
      $justthese = array("pkirisRaUrl");
      $result = ldap_get_info($base, $filter, $justthese);

      // Con la url de la RA construimos el nombre del fichero de su
      // configuracion
      $raUrl = $result[0]["pkirisraurl"][0];
      $confFile = $confDir."php/".$raUrl.".conf";

      // Abrimos el fichero para leer la clave privada
      $fd = fopen($confFile, "r");
      if ( $fd ) {
         while ( !feof ($fd) && !$retValue ) {
            $buf = fgets ($fd, 4096);
            if ( strstr($buf, "$"."raPrivKey =") ) {
               // Le quitamos a la clave privada el nombre de la variable, el
               // signo '=', las comillas y el ';'
               list ($k, $tmp) = split ("raPrivKey =", $buf);
               list ($k2, $tmp2 ) = split ("\"", $tmp);
               list ($tmp3, $k3 ) = split ("\"", $tmp2);
	       list ($privKey, $k4) = split (";", $tmp3);
	       $retValue = $privKey;
            }
         }															  
      }
   }
   return $retValue;
}
																	 

############################### VARIABLES #####################################

// Home Menu
$menu[0]["/policy/"] = "Pol&iacute;tica de la CA";
$menu[0]["/cacert/"] = "Obtener Certificado de la CA";
$menu[0]["/crt_list.php"] = "Certificados V&aacute;lidos";
$menu[0]["/crl/"] = "Listas de Revocaci&oacute;n";
$menu[0]["/tools/"] = "Descarga de Utilidades";
$menu[0]["/info.php"] = "Informaci&oacute;n de Contacto";
$menu[0]["/pki/pkiAdmin/"] = "Administraci&oacute;n de pkIRIS";
$menu[0]["/pki/pkiOper/"] = "Operadores de la CA";

// Public Menu
$menu[1]["csr_spkac.php?type=usr"] = "Solicitar Certificado de Usuario";
$menu[1]["csr_spkac.php?type=srv"] = "Solicitar Certificado de Servidor";
$menu[1]["crt_get.php"] = "Descargar Certificado";
$menu[1]["crr.php"] = "Revocar Certificado";
$menu[1]["crt_renew.php"] = "Renovar Certificado";

// RAs Admin Menu 
$menu[2]["csr_new.php"] = "Gesti&oacute;n de CSRs";
$menu[2]["data_export.php?type=ra2ca_pending"] = "Exportar CSRs";
$menu[2]["crr.php"] = "Revocar un Certificado";
$menu[2]["cert_search.php"] = "Consulta de Certificados";

// pkiAdmin Menu
$menu[3]["newRa.php"] = "Crear nueva RA";
$menu[3]["delRa.php"] = "Borrar RA";
$menu[3]["users_manage.php"] = "Gesti&oacute;n de usuarios";

// Ca Side Menu
$menu[4]["data_import.php"] = "Importar Solicitudes";
$menu[4]["manage.php"] = "Gestionar Solicitudes";
$menu[4]["gen_crl.php"] = "Generar CRLs";
$menu[4]["revoke.php"] = "Revocar Certificados";
$menu[4]["data_export.php?type=ca2ra_pending"] = "Exportar Certificados";
$menu[4]["raPrivKey_import.php"] = "Importar Claves";

// pkiOper Menu 
$menu[5]["data_import.php"] = "Importar Datos de la CA";
$menu[5]["manage.php"] = "xxxxxxxxxxxxxxxxxxxxx";
$menu[5]["gen_crl.php"] = "xxxxxxxxxxxxxxxxxxxxxx";
$menu[5]["data_export.php"] = "xxxxxxxxxxxxxxxxxxxxxx";

// Revocation Reasons Array
$revReasons[0] = "unspecified";
$revReasons[1] = "keyCompromise";
$revReasons[2] = "cACompromise";
$revReasons[3] = "affiliationChanged";
$revReasons[4] = "superseded";
$revReasons[5] = "cessationOfOperation";
$revReasons[6] = "certificateHold";
$revReasons[7] = "removeFromCRL";
$revReasons[8] = "privilegeWithdrawn";
$revReasons[9] = "aACompromise";

// All posibles status Array
$aStatus['new']="CSR Nueva";
$aStatus['renew'] = "CSR Renovada";  
$aStatus['approved']="CSR Aprobada";
$aStatus['ra2ca']="CSR Enviada a la CA";
$aStatus['*-denied']="CSR Rechazada por la RA";
$aStatus['*-refused']="CSR Rechazada por la CA";
$aStatus['issued']="Certificados emitidos";
$aStatus['revoke']="Certificados pendientes de revocaci&oacute;n";
$aStatus['revoked-*']="Certificados revocados";

$aAction['download']="Descarga de certificado";

// Trace elements positions 
$traceIndices['csr'] = '0';
$traceIndices['state'] = '1';
$traceIndices['date'] = '2';
$traceIndices['status'] = '3';
$traceIndices['sha1'] = '4';

// All posible ca manage actions array
   # CRRs
$caManageActions["crr"]["Revocar"] = "revoked-";
$caManageActions["crr"]["Aplazar"] = "crr-deferred";
$caManageActions["crr"]["Rechazar"] = "crr-refused";
   # CSRs
$caManageActions["csr"]["Firmar"] = "issued";
$caManageActions["csr"]["Aplazar"] = "csr-deferred";
$caManageActions["csr"]["Rechazar"] = "csr-refused";
   # RNRs
$caManageActions["rnr"]["Firmar"] = "issued";
$caManageActions["rnr"]["Aplazar"] = "rnr-deferred";
$caManageActions["rnr"]["Rechazar"] = "rnr-refused";
	 
// Year Range for certifacte list form
$def['dFromYYYY']="2005";
$def['dToYYYY']="2016";

###############################################################################

?>
